{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_Classification (C_NDClass (..), C_TypeHOClass (..), C_ConsHOClass (..), C_FuncHOClass (..), d_C_maxTypeHOClass, d_C_maximumTypeHOClass, d_C_maxConsHOClass, d_C_maximumConsHOClass, d_C_typeToConsHOClass, d_C_maxFuncHOClass, d_C_maximumFuncHOClass, d_C_typeToFuncHOClass) where

import Basics
import qualified Curry_Prelude

data C_NDClass
     = C_D
     | C_ND
     | Choice_C_NDClass Cover ID C_NDClass C_NDClass
     | Choices_C_NDClass Cover ID ([C_NDClass])
     | Fail_C_NDClass Cover FailInfo
     | Guard_C_NDClass Cover Constraints C_NDClass

instance Show C_NDClass where
  showsPrec d (Choice_C_NDClass cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_NDClass cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_NDClass cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_NDClass cd info) = showChar '!'
  showsPrec _ C_D = showString "D"
  showsPrec _ C_ND = showString "ND"


instance Read C_NDClass where
  readsPrec _ s = (readParen False (\r -> [ (C_D,r0) | (_,r0) <- readQualified "Classification" "D" r]) s) ++ (readParen False (\r -> [ (C_ND,r0) | (_,r0) <- readQualified "Classification" "ND" r]) s)


instance NonDet C_NDClass where
  choiceCons = Choice_C_NDClass
  choicesCons = Choices_C_NDClass
  failCons = Fail_C_NDClass
  guardCons = Guard_C_NDClass
  try (Choice_C_NDClass cd i x y) = tryChoice cd i x y
  try (Choices_C_NDClass cd i xs) = tryChoices cd i xs
  try (Fail_C_NDClass cd info) = Fail cd info
  try (Guard_C_NDClass cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_NDClass cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_NDClass cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_NDClass cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_NDClass cd i _) = error ("Classification.NDClass.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ (Fail_C_NDClass cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_NDClass cd c e) = f cd c e
  match _ _ _ _ _ f x = f x


instance Generable C_NDClass where
  generate s c = Choices_C_NDClass c (freeID [0,0] s) [C_D,C_ND]


instance NormalForm C_NDClass where
  ($!!) cont C_D d cs = cont C_D d cs
  ($!!) cont C_ND d cs = cont C_ND d cs
  ($!!) cont (Choice_C_NDClass cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_NDClass cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_NDClass cd c e) d cs = guardCons cd c (((cont $!! e) d) (addCs c cs))
  ($!!) _ (Fail_C_NDClass cd info) _ _ = failCons cd info
  ($##) cont C_D d cs = cont C_D d cs
  ($##) cont C_ND d cs = cont C_ND d cs
  ($##) cont (Choice_C_NDClass cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_NDClass cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_NDClass cd c e) d cs = guardCons cd c (((cont $## e) d) (addCs c cs))
  ($##) _ (Fail_C_NDClass cd info) _ _ = failCons cd info
  showCons C_D = "Classification.D"
  showCons C_ND = "Classification.ND"
  showCons x = error ("Classification.NDClass.showCons: no constructor: " ++ (show x))
  searchNF _ cont C_D = cont C_D
  searchNF _ cont C_ND = cont C_ND
  searchNF _ _ x = error ("Classification.NDClass.searchNF: no constructor: " ++ (show x))


instance Unifiable C_NDClass where
  (=.=) C_D C_D d cs = C_Success
  (=.=) C_ND C_ND d cs = C_Success
  (=.=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_D C_D d cs = C_Success
  (=.<=) C_ND C_ND d cs = C_Success
  (=.<=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  bind cd i C_D = ((i :=: (ChooseN 0 0)):(concat []))
  bind cd i C_ND = ((i :=: (ChooseN 1 0)):(concat []))
  bind d i (Choice_C_NDClass cd j x y) = [(ConstraintChoice cd j (bind d i x) (bind d i y))]
  bind d i (Choices_C_NDClass cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_NDClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (bind d i) xs))]
  bind _ _ (Choices_C_NDClass cd i _) = error ("Classification.NDClass.bind: Choices with ChoiceID: " ++ (show i))
  bind _ _ (Fail_C_NDClass cd info) = [(Unsolvable info)]
  bind d i (Guard_C_NDClass cd c e) = (getConstrList c) ++ (bind d i e)
  lazyBind cd i C_D = [(i :=: (ChooseN 0 0))]
  lazyBind cd i C_ND = [(i :=: (ChooseN 1 0))]
  lazyBind d i (Choice_C_NDClass cd j x y) = [(ConstraintChoice cd j (lazyBind d i x) (lazyBind d i y))]
  lazyBind d i (Choices_C_NDClass cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_NDClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (lazyBind d i) xs))]
  lazyBind _ _ (Choices_C_NDClass cd i _) = error ("Classification.NDClass.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ _ (Fail_C_NDClass cd info) = [(Unsolvable info)]
  lazyBind d i (Guard_C_NDClass cd c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind d i e)))]


instance Curry_Prelude.Curry C_NDClass where
  (=?=) (Choice_C_NDClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.=?= z) d) cs) (((y Curry_Prelude.=?= z) d) cs)
  (=?=) (Choices_C_NDClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.=?= y) d) cs) xs
  (=?=) (Guard_C_NDClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.=?= y) d) (addCs c cs))
  (=?=) (Fail_C_NDClass cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_NDClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.=?= x) d) cs) (((z Curry_Prelude.=?= y) d) cs)
  (=?=) y (Choices_C_NDClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.=?= x) d) cs) xs
  (=?=) y (Guard_C_NDClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.=?= e) d) (addCs c cs))
  (=?=) _ (Fail_C_NDClass cd info) _ _ = failCons cd info
  (=?=) C_D C_D d cs = Curry_Prelude.C_True
  (=?=) C_ND C_ND d cs = Curry_Prelude.C_True
  (=?=) _ _ d _ = Curry_Prelude.C_False
  (<?=) (Choice_C_NDClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.<?= z) d) cs) (((y Curry_Prelude.<?= z) d) cs)
  (<?=) (Choices_C_NDClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.<?= y) d) cs) xs
  (<?=) (Guard_C_NDClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.<?= y) d) (addCs c cs))
  (<?=) (Fail_C_NDClass cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_NDClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.<?= x) d) cs) (((z Curry_Prelude.<?= y) d) cs)
  (<?=) y (Choices_C_NDClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.<?= x) d) cs) xs
  (<?=) y (Guard_C_NDClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.<?= e) d) (addCs c cs))
  (<?=) _ (Fail_C_NDClass cd info) _ _ = failCons cd info
  (<?=) C_D C_D d cs = Curry_Prelude.C_True
  (<?=) C_D C_ND _ _ = Curry_Prelude.C_True
  (<?=) C_ND C_ND d cs = Curry_Prelude.C_True
  (<?=) _ _ d _ = Curry_Prelude.C_False


data C_TypeHOClass
     = C_TypeFO
     | C_TypeIO
     | C_TypeHO
     | Choice_C_TypeHOClass Cover ID C_TypeHOClass C_TypeHOClass
     | Choices_C_TypeHOClass Cover ID ([C_TypeHOClass])
     | Fail_C_TypeHOClass Cover FailInfo
     | Guard_C_TypeHOClass Cover Constraints C_TypeHOClass

instance Show C_TypeHOClass where
  showsPrec d (Choice_C_TypeHOClass cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_TypeHOClass cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_TypeHOClass cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_TypeHOClass cd info) = showChar '!'
  showsPrec _ C_TypeFO = showString "TypeFO"
  showsPrec _ C_TypeIO = showString "TypeIO"
  showsPrec _ C_TypeHO = showString "TypeHO"


instance Read C_TypeHOClass where
  readsPrec _ s = (readParen False (\r -> [ (C_TypeFO,r0) | (_,r0) <- readQualified "Classification" "TypeFO" r]) s) ++ ((readParen False (\r -> [ (C_TypeIO,r0) | (_,r0) <- readQualified "Classification" "TypeIO" r]) s) ++ (readParen False (\r -> [ (C_TypeHO,r0) | (_,r0) <- readQualified "Classification" "TypeHO" r]) s))


instance NonDet C_TypeHOClass where
  choiceCons = Choice_C_TypeHOClass
  choicesCons = Choices_C_TypeHOClass
  failCons = Fail_C_TypeHOClass
  guardCons = Guard_C_TypeHOClass
  try (Choice_C_TypeHOClass cd i x y) = tryChoice cd i x y
  try (Choices_C_TypeHOClass cd i xs) = tryChoices cd i xs
  try (Fail_C_TypeHOClass cd info) = Fail cd info
  try (Guard_C_TypeHOClass cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_TypeHOClass cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_TypeHOClass cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_TypeHOClass cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_TypeHOClass cd i _) = error ("Classification.TypeHOClass.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ (Fail_C_TypeHOClass cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_TypeHOClass cd c e) = f cd c e
  match _ _ _ _ _ f x = f x


instance Generable C_TypeHOClass where
  generate s c = Choices_C_TypeHOClass c (freeID [0,0,0] s) [C_TypeFO,C_TypeIO,C_TypeHO]


instance NormalForm C_TypeHOClass where
  ($!!) cont C_TypeFO d cs = cont C_TypeFO d cs
  ($!!) cont C_TypeIO d cs = cont C_TypeIO d cs
  ($!!) cont C_TypeHO d cs = cont C_TypeHO d cs
  ($!!) cont (Choice_C_TypeHOClass cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_TypeHOClass cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_TypeHOClass cd c e) d cs = guardCons cd c (((cont $!! e) d) (addCs c cs))
  ($!!) _ (Fail_C_TypeHOClass cd info) _ _ = failCons cd info
  ($##) cont C_TypeFO d cs = cont C_TypeFO d cs
  ($##) cont C_TypeIO d cs = cont C_TypeIO d cs
  ($##) cont C_TypeHO d cs = cont C_TypeHO d cs
  ($##) cont (Choice_C_TypeHOClass cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_TypeHOClass cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_TypeHOClass cd c e) d cs = guardCons cd c (((cont $## e) d) (addCs c cs))
  ($##) _ (Fail_C_TypeHOClass cd info) _ _ = failCons cd info
  showCons C_TypeFO = "Classification.TypeFO"
  showCons C_TypeIO = "Classification.TypeIO"
  showCons C_TypeHO = "Classification.TypeHO"
  showCons x = error ("Classification.TypeHOClass.showCons: no constructor: " ++ (show x))
  searchNF _ cont C_TypeFO = cont C_TypeFO
  searchNF _ cont C_TypeIO = cont C_TypeIO
  searchNF _ cont C_TypeHO = cont C_TypeHO
  searchNF _ _ x = error ("Classification.TypeHOClass.searchNF: no constructor: " ++ (show x))


instance Unifiable C_TypeHOClass where
  (=.=) C_TypeFO C_TypeFO d cs = C_Success
  (=.=) C_TypeIO C_TypeIO d cs = C_Success
  (=.=) C_TypeHO C_TypeHO d cs = C_Success
  (=.=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_TypeFO C_TypeFO d cs = C_Success
  (=.<=) C_TypeIO C_TypeIO d cs = C_Success
  (=.<=) C_TypeHO C_TypeHO d cs = C_Success
  (=.<=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  bind cd i C_TypeFO = ((i :=: (ChooseN 0 0)):(concat []))
  bind cd i C_TypeIO = ((i :=: (ChooseN 1 0)):(concat []))
  bind cd i C_TypeHO = ((i :=: (ChooseN 2 0)):(concat []))
  bind d i (Choice_C_TypeHOClass cd j x y) = [(ConstraintChoice cd j (bind d i x) (bind d i y))]
  bind d i (Choices_C_TypeHOClass cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_TypeHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (bind d i) xs))]
  bind _ _ (Choices_C_TypeHOClass cd i _) = error ("Classification.TypeHOClass.bind: Choices with ChoiceID: " ++ (show i))
  bind _ _ (Fail_C_TypeHOClass cd info) = [(Unsolvable info)]
  bind d i (Guard_C_TypeHOClass cd c e) = (getConstrList c) ++ (bind d i e)
  lazyBind cd i C_TypeFO = [(i :=: (ChooseN 0 0))]
  lazyBind cd i C_TypeIO = [(i :=: (ChooseN 1 0))]
  lazyBind cd i C_TypeHO = [(i :=: (ChooseN 2 0))]
  lazyBind d i (Choice_C_TypeHOClass cd j x y) = [(ConstraintChoice cd j (lazyBind d i x) (lazyBind d i y))]
  lazyBind d i (Choices_C_TypeHOClass cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_TypeHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (lazyBind d i) xs))]
  lazyBind _ _ (Choices_C_TypeHOClass cd i _) = error ("Classification.TypeHOClass.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ _ (Fail_C_TypeHOClass cd info) = [(Unsolvable info)]
  lazyBind d i (Guard_C_TypeHOClass cd c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind d i e)))]


instance Curry_Prelude.Curry C_TypeHOClass where
  (=?=) (Choice_C_TypeHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.=?= z) d) cs) (((y Curry_Prelude.=?= z) d) cs)
  (=?=) (Choices_C_TypeHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.=?= y) d) cs) xs
  (=?=) (Guard_C_TypeHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.=?= y) d) (addCs c cs))
  (=?=) (Fail_C_TypeHOClass cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_TypeHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.=?= x) d) cs) (((z Curry_Prelude.=?= y) d) cs)
  (=?=) y (Choices_C_TypeHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.=?= x) d) cs) xs
  (=?=) y (Guard_C_TypeHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.=?= e) d) (addCs c cs))
  (=?=) _ (Fail_C_TypeHOClass cd info) _ _ = failCons cd info
  (=?=) C_TypeFO C_TypeFO d cs = Curry_Prelude.C_True
  (=?=) C_TypeIO C_TypeIO d cs = Curry_Prelude.C_True
  (=?=) C_TypeHO C_TypeHO d cs = Curry_Prelude.C_True
  (=?=) _ _ d _ = Curry_Prelude.C_False
  (<?=) (Choice_C_TypeHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.<?= z) d) cs) (((y Curry_Prelude.<?= z) d) cs)
  (<?=) (Choices_C_TypeHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.<?= y) d) cs) xs
  (<?=) (Guard_C_TypeHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.<?= y) d) (addCs c cs))
  (<?=) (Fail_C_TypeHOClass cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_TypeHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.<?= x) d) cs) (((z Curry_Prelude.<?= y) d) cs)
  (<?=) y (Choices_C_TypeHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.<?= x) d) cs) xs
  (<?=) y (Guard_C_TypeHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.<?= e) d) (addCs c cs))
  (<?=) _ (Fail_C_TypeHOClass cd info) _ _ = failCons cd info
  (<?=) C_TypeFO C_TypeFO d cs = Curry_Prelude.C_True
  (<?=) C_TypeFO C_TypeIO _ _ = Curry_Prelude.C_True
  (<?=) C_TypeFO C_TypeHO _ _ = Curry_Prelude.C_True
  (<?=) C_TypeIO C_TypeIO d cs = Curry_Prelude.C_True
  (<?=) C_TypeIO C_TypeHO _ _ = Curry_Prelude.C_True
  (<?=) C_TypeHO C_TypeHO d cs = Curry_Prelude.C_True
  (<?=) _ _ d _ = Curry_Prelude.C_False


data C_ConsHOClass
     = C_ConsFO
     | C_ConsHO
     | Choice_C_ConsHOClass Cover ID C_ConsHOClass C_ConsHOClass
     | Choices_C_ConsHOClass Cover ID ([C_ConsHOClass])
     | Fail_C_ConsHOClass Cover FailInfo
     | Guard_C_ConsHOClass Cover Constraints C_ConsHOClass

instance Show C_ConsHOClass where
  showsPrec d (Choice_C_ConsHOClass cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_ConsHOClass cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_ConsHOClass cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_ConsHOClass cd info) = showChar '!'
  showsPrec _ C_ConsFO = showString "ConsFO"
  showsPrec _ C_ConsHO = showString "ConsHO"


instance Read C_ConsHOClass where
  readsPrec _ s = (readParen False (\r -> [ (C_ConsFO,r0) | (_,r0) <- readQualified "Classification" "ConsFO" r]) s) ++ (readParen False (\r -> [ (C_ConsHO,r0) | (_,r0) <- readQualified "Classification" "ConsHO" r]) s)


instance NonDet C_ConsHOClass where
  choiceCons = Choice_C_ConsHOClass
  choicesCons = Choices_C_ConsHOClass
  failCons = Fail_C_ConsHOClass
  guardCons = Guard_C_ConsHOClass
  try (Choice_C_ConsHOClass cd i x y) = tryChoice cd i x y
  try (Choices_C_ConsHOClass cd i xs) = tryChoices cd i xs
  try (Fail_C_ConsHOClass cd info) = Fail cd info
  try (Guard_C_ConsHOClass cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_ConsHOClass cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_ConsHOClass cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_ConsHOClass cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_ConsHOClass cd i _) = error ("Classification.ConsHOClass.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ (Fail_C_ConsHOClass cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_ConsHOClass cd c e) = f cd c e
  match _ _ _ _ _ f x = f x


instance Generable C_ConsHOClass where
  generate s c = Choices_C_ConsHOClass c (freeID [0,0] s) [C_ConsFO,C_ConsHO]


instance NormalForm C_ConsHOClass where
  ($!!) cont C_ConsFO d cs = cont C_ConsFO d cs
  ($!!) cont C_ConsHO d cs = cont C_ConsHO d cs
  ($!!) cont (Choice_C_ConsHOClass cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_ConsHOClass cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_ConsHOClass cd c e) d cs = guardCons cd c (((cont $!! e) d) (addCs c cs))
  ($!!) _ (Fail_C_ConsHOClass cd info) _ _ = failCons cd info
  ($##) cont C_ConsFO d cs = cont C_ConsFO d cs
  ($##) cont C_ConsHO d cs = cont C_ConsHO d cs
  ($##) cont (Choice_C_ConsHOClass cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_ConsHOClass cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_ConsHOClass cd c e) d cs = guardCons cd c (((cont $## e) d) (addCs c cs))
  ($##) _ (Fail_C_ConsHOClass cd info) _ _ = failCons cd info
  showCons C_ConsFO = "Classification.ConsFO"
  showCons C_ConsHO = "Classification.ConsHO"
  showCons x = error ("Classification.ConsHOClass.showCons: no constructor: " ++ (show x))
  searchNF _ cont C_ConsFO = cont C_ConsFO
  searchNF _ cont C_ConsHO = cont C_ConsHO
  searchNF _ _ x = error ("Classification.ConsHOClass.searchNF: no constructor: " ++ (show x))


instance Unifiable C_ConsHOClass where
  (=.=) C_ConsFO C_ConsFO d cs = C_Success
  (=.=) C_ConsHO C_ConsHO d cs = C_Success
  (=.=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_ConsFO C_ConsFO d cs = C_Success
  (=.<=) C_ConsHO C_ConsHO d cs = C_Success
  (=.<=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  bind cd i C_ConsFO = ((i :=: (ChooseN 0 0)):(concat []))
  bind cd i C_ConsHO = ((i :=: (ChooseN 1 0)):(concat []))
  bind d i (Choice_C_ConsHOClass cd j x y) = [(ConstraintChoice cd j (bind d i x) (bind d i y))]
  bind d i (Choices_C_ConsHOClass cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_ConsHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (bind d i) xs))]
  bind _ _ (Choices_C_ConsHOClass cd i _) = error ("Classification.ConsHOClass.bind: Choices with ChoiceID: " ++ (show i))
  bind _ _ (Fail_C_ConsHOClass cd info) = [(Unsolvable info)]
  bind d i (Guard_C_ConsHOClass cd c e) = (getConstrList c) ++ (bind d i e)
  lazyBind cd i C_ConsFO = [(i :=: (ChooseN 0 0))]
  lazyBind cd i C_ConsHO = [(i :=: (ChooseN 1 0))]
  lazyBind d i (Choice_C_ConsHOClass cd j x y) = [(ConstraintChoice cd j (lazyBind d i x) (lazyBind d i y))]
  lazyBind d i (Choices_C_ConsHOClass cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_ConsHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (lazyBind d i) xs))]
  lazyBind _ _ (Choices_C_ConsHOClass cd i _) = error ("Classification.ConsHOClass.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ _ (Fail_C_ConsHOClass cd info) = [(Unsolvable info)]
  lazyBind d i (Guard_C_ConsHOClass cd c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind d i e)))]


instance Curry_Prelude.Curry C_ConsHOClass where
  (=?=) (Choice_C_ConsHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.=?= z) d) cs) (((y Curry_Prelude.=?= z) d) cs)
  (=?=) (Choices_C_ConsHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.=?= y) d) cs) xs
  (=?=) (Guard_C_ConsHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.=?= y) d) (addCs c cs))
  (=?=) (Fail_C_ConsHOClass cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_ConsHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.=?= x) d) cs) (((z Curry_Prelude.=?= y) d) cs)
  (=?=) y (Choices_C_ConsHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.=?= x) d) cs) xs
  (=?=) y (Guard_C_ConsHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.=?= e) d) (addCs c cs))
  (=?=) _ (Fail_C_ConsHOClass cd info) _ _ = failCons cd info
  (=?=) C_ConsFO C_ConsFO d cs = Curry_Prelude.C_True
  (=?=) C_ConsHO C_ConsHO d cs = Curry_Prelude.C_True
  (=?=) _ _ d _ = Curry_Prelude.C_False
  (<?=) (Choice_C_ConsHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.<?= z) d) cs) (((y Curry_Prelude.<?= z) d) cs)
  (<?=) (Choices_C_ConsHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.<?= y) d) cs) xs
  (<?=) (Guard_C_ConsHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.<?= y) d) (addCs c cs))
  (<?=) (Fail_C_ConsHOClass cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_ConsHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.<?= x) d) cs) (((z Curry_Prelude.<?= y) d) cs)
  (<?=) y (Choices_C_ConsHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.<?= x) d) cs) xs
  (<?=) y (Guard_C_ConsHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.<?= e) d) (addCs c cs))
  (<?=) _ (Fail_C_ConsHOClass cd info) _ _ = failCons cd info
  (<?=) C_ConsFO C_ConsFO d cs = Curry_Prelude.C_True
  (<?=) C_ConsFO C_ConsHO _ _ = Curry_Prelude.C_True
  (<?=) C_ConsHO C_ConsHO d cs = Curry_Prelude.C_True
  (<?=) _ _ d _ = Curry_Prelude.C_False


data C_FuncHOClass
     = C_FuncFO
     | C_FuncHORes Curry_Prelude.C_Int
     | C_FuncHO
     | Choice_C_FuncHOClass Cover ID C_FuncHOClass C_FuncHOClass
     | Choices_C_FuncHOClass Cover ID ([C_FuncHOClass])
     | Fail_C_FuncHOClass Cover FailInfo
     | Guard_C_FuncHOClass Cover Constraints C_FuncHOClass

instance Show C_FuncHOClass where
  showsPrec d (Choice_C_FuncHOClass cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_FuncHOClass cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_FuncHOClass cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_FuncHOClass cd info) = showChar '!'
  showsPrec _ C_FuncFO = showString "FuncFO"
  showsPrec _ (C_FuncHORes x1) = (showString "(FuncHORes") . ((showChar ' ') . ((shows x1) . (showChar ')')))
  showsPrec _ C_FuncHO = showString "FuncHO"


instance Read C_FuncHOClass where
  readsPrec d s = (readParen False (\r -> [ (C_FuncFO,r0) | (_,r0) <- readQualified "Classification" "FuncFO" r]) s) ++ ((readParen (d > 10) (\r -> [ (C_FuncHORes x1,r1) | (_,r0) <- readQualified "Classification" "FuncHORes" r, (x1,r1) <- readsPrec 11 r0]) s) ++ (readParen False (\r -> [ (C_FuncHO,r0) | (_,r0) <- readQualified "Classification" "FuncHO" r]) s))


instance NonDet C_FuncHOClass where
  choiceCons = Choice_C_FuncHOClass
  choicesCons = Choices_C_FuncHOClass
  failCons = Fail_C_FuncHOClass
  guardCons = Guard_C_FuncHOClass
  try (Choice_C_FuncHOClass cd i x y) = tryChoice cd i x y
  try (Choices_C_FuncHOClass cd i xs) = tryChoices cd i xs
  try (Fail_C_FuncHOClass cd info) = Fail cd info
  try (Guard_C_FuncHOClass cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_FuncHOClass cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_FuncHOClass cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_FuncHOClass cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_FuncHOClass cd i _) = error ("Classification.FuncHOClass.match: Choices with ChoiceID " ++ (show i))
  match _ _ _ f _ _ (Fail_C_FuncHOClass cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_FuncHOClass cd c e) = f cd c e
  match _ _ _ _ _ f x = f x


instance Generable C_FuncHOClass where
  generate s c = Choices_C_FuncHOClass c (freeID [0,1,0] s) [C_FuncFO,(C_FuncHORes (generate (leftSupply s) c)),C_FuncHO]


instance NormalForm C_FuncHOClass where
  ($!!) cont C_FuncFO d cs = cont C_FuncFO d cs
  ($!!) cont (C_FuncHORes x1) d cs = (((\y1 d cs -> cont (C_FuncHORes y1) d cs) $!! x1) d) cs
  ($!!) cont C_FuncHO d cs = cont C_FuncHO d cs
  ($!!) cont (Choice_C_FuncHOClass cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_FuncHOClass cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_FuncHOClass cd c e) d cs = guardCons cd c (((cont $!! e) d) (addCs c cs))
  ($!!) _ (Fail_C_FuncHOClass cd info) _ _ = failCons cd info
  ($##) cont C_FuncFO d cs = cont C_FuncFO d cs
  ($##) cont (C_FuncHORes x1) d cs = (((\y1 d cs -> cont (C_FuncHORes y1) d cs) $## x1) d) cs
  ($##) cont C_FuncHO d cs = cont C_FuncHO d cs
  ($##) cont (Choice_C_FuncHOClass cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_FuncHOClass cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_FuncHOClass cd c e) d cs = guardCons cd c (((cont $## e) d) (addCs c cs))
  ($##) _ (Fail_C_FuncHOClass cd info) _ _ = failCons cd info
  showCons C_FuncFO = "Classification.FuncFO"
  showCons (C_FuncHORes _) = "Classification.FuncHORes _"
  showCons C_FuncHO = "Classification.FuncHO"
  showCons x = error ("Classification.FuncHOClass.showCons: no constructor: " ++ (show x))
  searchNF _ cont C_FuncFO = cont C_FuncFO
  searchNF search cont (C_FuncHORes x1) = search (\y1 -> cont (C_FuncHORes y1)) x1
  searchNF _ cont C_FuncHO = cont C_FuncHO
  searchNF _ _ x = error ("Classification.FuncHOClass.searchNF: no constructor: " ++ (show x))


instance Unifiable C_FuncHOClass where
  (=.=) C_FuncFO C_FuncFO d cs = C_Success
  (=.=) (C_FuncHORes x1) (C_FuncHORes y1) d cs = ((x1 =:= y1) d) cs
  (=.=) C_FuncHO C_FuncHO d cs = C_Success
  (=.=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_FuncFO C_FuncFO d cs = C_Success
  (=.<=) (C_FuncHORes x1) (C_FuncHORes y1) d cs = ((x1 =:<= y1) d) cs
  (=.<=) C_FuncHO C_FuncHO d cs = C_Success
  (=.<=) a b cd _ = Fail_C_Success cd (unificationFail (showCons a) (showCons b))
  bind cd i C_FuncFO = ((i :=: (ChooseN 0 0)):(concat []))
  bind cd i (C_FuncHORes x3) = ((i :=: (ChooseN 1 1)):(concat [(bind cd (leftID i) x3)]))
  bind cd i C_FuncHO = ((i :=: (ChooseN 2 0)):(concat []))
  bind d i (Choice_C_FuncHOClass cd j x y) = [(ConstraintChoice cd j (bind d i x) (bind d i y))]
  bind d i (Choices_C_FuncHOClass cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_FuncHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (bind d i) xs))]
  bind _ _ (Choices_C_FuncHOClass cd i _) = error ("Classification.FuncHOClass.bind: Choices with ChoiceID: " ++ (show i))
  bind _ _ (Fail_C_FuncHOClass cd info) = [(Unsolvable info)]
  bind d i (Guard_C_FuncHOClass cd c e) = (getConstrList c) ++ (bind d i e)
  lazyBind cd i C_FuncFO = [(i :=: (ChooseN 0 0))]
  lazyBind cd i (C_FuncHORes x3) = [(i :=: (ChooseN 1 1)),((leftID i) :=: (LazyBind (lazyBind cd (leftID i) x3)))]
  lazyBind cd i C_FuncHO = [(i :=: (ChooseN 2 0))]
  lazyBind d i (Choice_C_FuncHOClass cd j x y) = [(ConstraintChoice cd j (lazyBind d i x) (lazyBind d i y))]
  lazyBind d i (Choices_C_FuncHOClass cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j xs
  lazyBind d i (Choices_C_FuncHOClass cd j@(NarrowedID _ _) xs) = [(ConstraintChoices cd j (map (lazyBind d i) xs))]
  lazyBind _ _ (Choices_C_FuncHOClass cd i _) = error ("Classification.FuncHOClass.lazyBind: Choices with ChoiceID: " ++ (show i))
  lazyBind _ _ (Fail_C_FuncHOClass cd info) = [(Unsolvable info)]
  lazyBind d i (Guard_C_FuncHOClass cd c e) = (getConstrList c) ++ [(i :=: (LazyBind (lazyBind d i e)))]


instance Curry_Prelude.Curry C_FuncHOClass where
  (=?=) (Choice_C_FuncHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.=?= z) d) cs) (((y Curry_Prelude.=?= z) d) cs)
  (=?=) (Choices_C_FuncHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.=?= y) d) cs) xs
  (=?=) (Guard_C_FuncHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.=?= y) d) (addCs c cs))
  (=?=) (Fail_C_FuncHOClass cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_FuncHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.=?= x) d) cs) (((z Curry_Prelude.=?= y) d) cs)
  (=?=) y (Choices_C_FuncHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.=?= x) d) cs) xs
  (=?=) y (Guard_C_FuncHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.=?= e) d) (addCs c cs))
  (=?=) _ (Fail_C_FuncHOClass cd info) _ _ = failCons cd info
  (=?=) C_FuncFO C_FuncFO d cs = Curry_Prelude.C_True
  (=?=) (C_FuncHORes x1) (C_FuncHORes y1) d cs = ((x1 Curry_Prelude.=?= y1) d) cs
  (=?=) C_FuncHO C_FuncHO d cs = Curry_Prelude.C_True
  (=?=) _ _ d _ = Curry_Prelude.C_False
  (<?=) (Choice_C_FuncHOClass cd i x y) z d cs = narrow cd i (((x Curry_Prelude.<?= z) d) cs) (((y Curry_Prelude.<?= z) d) cs)
  (<?=) (Choices_C_FuncHOClass cd i xs) y d cs = narrows cs cd i (\x -> ((x Curry_Prelude.<?= y) d) cs) xs
  (<?=) (Guard_C_FuncHOClass cd c e) y d cs = guardCons cd c (((e Curry_Prelude.<?= y) d) (addCs c cs))
  (<?=) (Fail_C_FuncHOClass cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_FuncHOClass cd i x y) d cs = narrow cd i (((z Curry_Prelude.<?= x) d) cs) (((z Curry_Prelude.<?= y) d) cs)
  (<?=) y (Choices_C_FuncHOClass cd i xs) d cs = narrows cs cd i (\x -> ((y Curry_Prelude.<?= x) d) cs) xs
  (<?=) y (Guard_C_FuncHOClass cd c e) d cs = guardCons cd c (((y Curry_Prelude.<?= e) d) (addCs c cs))
  (<?=) _ (Fail_C_FuncHOClass cd info) _ _ = failCons cd info
  (<?=) C_FuncFO C_FuncFO d cs = Curry_Prelude.C_True
  (<?=) C_FuncFO (C_FuncHORes _) _ _ = Curry_Prelude.C_True
  (<?=) C_FuncFO C_FuncHO _ _ = Curry_Prelude.C_True
  (<?=) (C_FuncHORes x1) (C_FuncHORes y1) d cs = ((x1 Curry_Prelude.<?= y1) d) cs
  (<?=) (C_FuncHORes _) C_FuncHO _ _ = Curry_Prelude.C_True
  (<?=) C_FuncHO C_FuncHO d cs = Curry_Prelude.C_True
  (<?=) _ _ d _ = Curry_Prelude.C_False


d_C_maxTypeHOClass :: C_TypeHOClass -> C_TypeHOClass -> Cover -> ConstStore -> C_TypeHOClass
d_C_maxTypeHOClass x1 x2 cd cs = case x1 of
     C_TypeFO -> x2
     C_TypeIO -> d_C__case_2 x2 cd cs
     C_TypeHO -> C_TypeHO
     (Choice_C_TypeHOClass d i l r) -> narrow d i (d_C_maxTypeHOClass l x2 cd cs) (d_C_maxTypeHOClass r x2 cd cs)
     (Choices_C_TypeHOClass d i xs) -> narrows cs d i (\z -> d_C_maxTypeHOClass z x2 cd cs) xs
     (Guard_C_TypeHOClass d c e) -> guardCons d c ((d_C_maxTypeHOClass e x2 cd) $! (addCs c cs))
     (Fail_C_TypeHOClass d info) -> failCons d (traceFail "Classification.maxTypeHOClass" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Classification.maxTypeHOClass" (showCons x1))

d_C_maximumTypeHOClass :: Curry_Prelude.OP_List C_TypeHOClass -> Cover -> ConstStore -> C_TypeHOClass
d_C_maximumTypeHOClass x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id d_C_maxTypeHOClass) C_TypeFO x1 cd cs

d_C_maxConsHOClass :: C_ConsHOClass -> C_ConsHOClass -> Cover -> ConstStore -> C_ConsHOClass
d_C_maxConsHOClass x1 x2 cd cs = case x1 of
     C_ConsFO -> x2
     C_ConsHO -> C_ConsHO
     (Choice_C_ConsHOClass d i l r) -> narrow d i (d_C_maxConsHOClass l x2 cd cs) (d_C_maxConsHOClass r x2 cd cs)
     (Choices_C_ConsHOClass d i xs) -> narrows cs d i (\z -> d_C_maxConsHOClass z x2 cd cs) xs
     (Guard_C_ConsHOClass d c e) -> guardCons d c ((d_C_maxConsHOClass e x2 cd) $! (addCs c cs))
     (Fail_C_ConsHOClass d info) -> failCons d (traceFail "Classification.maxConsHOClass" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Classification.maxConsHOClass" (showCons x1))

d_C_maximumConsHOClass :: Curry_Prelude.OP_List C_ConsHOClass -> Cover -> ConstStore -> C_ConsHOClass
d_C_maximumConsHOClass x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id d_C_maxConsHOClass) C_ConsFO x1 cd cs

d_C_typeToConsHOClass :: C_TypeHOClass -> Cover -> ConstStore -> C_ConsHOClass
d_C_typeToConsHOClass x1 cd cs = case x1 of
     C_TypeFO -> C_ConsFO
     C_TypeIO -> C_ConsFO
     C_TypeHO -> C_ConsHO
     (Choice_C_TypeHOClass d i l r) -> narrow d i (d_C_typeToConsHOClass l cd cs) (d_C_typeToConsHOClass r cd cs)
     (Choices_C_TypeHOClass d i xs) -> narrows cs d i (\z -> d_C_typeToConsHOClass z cd cs) xs
     (Guard_C_TypeHOClass d c e) -> guardCons d c ((d_C_typeToConsHOClass e cd) $! (addCs c cs))
     (Fail_C_TypeHOClass d info) -> failCons d (traceFail "Classification.typeToConsHOClass" [(show x1)] info)
     _ -> failCons cd (consFail "Classification.typeToConsHOClass" (showCons x1))

d_C_maxFuncHOClass :: C_FuncHOClass -> C_FuncHOClass -> Cover -> ConstStore -> C_FuncHOClass
d_C_maxFuncHOClass x1 x2 cd cs = case x1 of
     C_FuncFO -> x2
     (C_FuncHORes x3) -> d_C__case_1 x1 x2 cd cs
     C_FuncHO -> C_FuncHO
     (Choice_C_FuncHOClass d i l r) -> narrow d i (d_C_maxFuncHOClass l x2 cd cs) (d_C_maxFuncHOClass r x2 cd cs)
     (Choices_C_FuncHOClass d i xs) -> narrows cs d i (\z -> d_C_maxFuncHOClass z x2 cd cs) xs
     (Guard_C_FuncHOClass d c e) -> guardCons d c ((d_C_maxFuncHOClass e x2 cd) $! (addCs c cs))
     (Fail_C_FuncHOClass d info) -> failCons d (traceFail "Classification.maxFuncHOClass" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Classification.maxFuncHOClass" (showCons x1))

d_C_maximumFuncHOClass :: Curry_Prelude.OP_List C_FuncHOClass -> Cover -> ConstStore -> C_FuncHOClass
d_C_maximumFuncHOClass x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id d_C_maxFuncHOClass) C_FuncFO x1 cd cs

d_C_typeToFuncHOClass :: Curry_Prelude.C_Bool -> C_TypeHOClass -> Cover -> ConstStore -> C_FuncHOClass
d_C_typeToFuncHOClass x1 x2 cd cs = case x2 of
     C_TypeFO -> C_FuncFO
     C_TypeIO -> d_C__case_0 x1 cd cs
     C_TypeHO -> C_FuncHO
     (Choice_C_TypeHOClass d i l r) -> narrow d i (d_C_typeToFuncHOClass x1 l cd cs) (d_C_typeToFuncHOClass x1 r cd cs)
     (Choices_C_TypeHOClass d i xs) -> narrows cs d i (\z -> d_C_typeToFuncHOClass x1 z cd cs) xs
     (Guard_C_TypeHOClass d c e) -> guardCons d c ((d_C_typeToFuncHOClass x1 e cd) $! (addCs c cs))
     (Fail_C_TypeHOClass d info) -> failCons d (traceFail "Classification.typeToFuncHOClass" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Classification.typeToFuncHOClass" (showCons x2))

d_C__case_0 :: Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_FuncHOClass
d_C__case_0 x1 cd cs = case x1 of
     Curry_Prelude.C_True -> C_FuncHO
     Curry_Prelude.C_False -> C_FuncFO
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_0 l cd cs) (d_C__case_0 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_0 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_0 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Classification._case_0" [(show x1)] info)
     _ -> failCons cd (consFail "Classification._case_0" (showCons x1))

d_C__case_1 :: C_FuncHOClass -> C_FuncHOClass -> Cover -> ConstStore -> C_FuncHOClass
d_C__case_1 x1 x2 cd cs = case x2 of
     C_FuncFO -> x1
     (C_FuncHORes x4) -> Curry_Prelude.d_C_error (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'H'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) Curry_Prelude.OP_List))))))))))))))))))))))))))))) cd cs
     C_FuncHO -> C_FuncHO
     (Choice_C_FuncHOClass d i l r) -> narrow d i (d_C__case_1 x1 l cd cs) (d_C__case_1 x1 r cd cs)
     (Choices_C_FuncHOClass d i xs) -> narrows cs d i (\z -> d_C__case_1 x1 z cd cs) xs
     (Guard_C_FuncHOClass d c e) -> guardCons d c ((d_C__case_1 x1 e cd) $! (addCs c cs))
     (Fail_C_FuncHOClass d info) -> failCons d (traceFail "Classification._case_1" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Classification._case_1" (showCons x2))

d_C__case_2 :: C_TypeHOClass -> Cover -> ConstStore -> C_TypeHOClass
d_C__case_2 x2 cd cs = case x2 of
     C_TypeFO -> C_TypeIO
     C_TypeIO -> C_TypeIO
     C_TypeHO -> C_TypeHO
     (Choice_C_TypeHOClass d i l r) -> narrow d i (d_C__case_2 l cd cs) (d_C__case_2 r cd cs)
     (Choices_C_TypeHOClass d i xs) -> narrows cs d i (\z -> d_C__case_2 z cd cs) xs
     (Guard_C_TypeHOClass d c e) -> guardCons d c ((d_C__case_2 e cd) $! (addCs c cs))
     (Fail_C_TypeHOClass d info) -> failCons d (traceFail "Classification._case_2" [(show x2)] info)
     _ -> failCons cd (consFail "Classification._case_2" (showCons x2))