{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}


module Curry_Inference (C_TypeEnv, d_C_inferProg, d_C_inferProgFromProgEnv, d_C_inferProgEnv, nd_C_inferProgEnv, d_C_inferFunction, d_C_inferFunctionEnv, nd_C_inferFunctionEnv, d_C_getTypeEnv, nd_C_getTypeEnv, d_C_getTypeEnvFromProgEnv, nd_C_getTypeEnvFromProgEnv) where

import Basics
import qualified Curry_AFCSubst
import qualified Curry_AnnotatedFlatCurry
import qualified Curry_AnnotatedFlatCurryGoodies
import qualified Curry_ErrorState
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_Unification
import qualified Curry_UnificationSpec

type C_TypeEnv = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr

type C_TIM t0 = Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))

type C_TypeEqs = Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)

type C_NormState = Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)

type C_NormStateM t0 = Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))

d_C_inferProg :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
d_C_inferProg x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x1 cd cs) (d_OP_inferProg_dot_uscore_hash_lambda1 x1) cd cs

d_OP_inferProg_dot_uscore_hash_lambda1 :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
d_OP_inferProg_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.d_C_return (d_C_inferProgEnv x2 x1 cd cs) cd cs

nd_OP_inferProg_dot_uscore_hash_lambda1 :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
nd_OP_inferProg_dot_uscore_hash_lambda1 x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.d_C_return (let
                in (nd_C_inferProgEnv x2 x1 s0 cd cs)) cd cs)))

d_C_inferProgFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_C_inferProgFromProgEnv x1 x2 cd cs = d_C__case_19 x2 x1 (d_C_getTypeEnvFromProgEnv x1 x2 cd cs) cd cs

d_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_C_inferProgEnv x1 x2 cd cs = Curry_ErrorState.d_C_evalES (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annProg x2 cd cs) d_C_inferAProg) (d_C_initTIM x1 cd cs) cd cs

nd_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
nd_C_inferProgEnv x1 x2 s cd cs = let
     s3 = s
      in (seq s3 (let
          s2 = leftSupply s3
          s4 = rightSupply s3
          s0 = leftSupply s4
          s1 = rightSupply s4
           in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_C_evalES (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_annProg x2 s0 cd cs)) (wrapNX id nd_C_inferAProg)))) (let
                in (nd_C_initTIM x1 s1 cd cs)) s2 cd cs)))))))

d_C_inferFunction :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
d_C_inferFunction x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x2 cd cs) (d_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2) cd cs

d_OP_inferFunction_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
d_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2 x3 cd cs = Curry_Prelude.d_C_return (d_C_inferFunctionEnv x3 x1 x2 cd cs) cd cs

nd_OP_inferFunction_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
nd_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.d_C_return (let
                in (nd_C_inferFunctionEnv x3 x1 x2 s0 cd cs)) cd cs)))

d_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
d_C_inferFunctionEnv x1 x2 x3 cd cs = case x3 of
     (Curry_FlatCurry.C_Prog x4 x5 x6 x7 x8) -> d_C__case_18 x7 x2 x1 (Curry_Prelude.d_C_apply (Curry_List.d_C_find (d_OP_inferFunctionEnv_dot_hasName_dot_20 x2) cd cs) x7 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (d_C_inferFunctionEnv x1 x2 l cd cs) (d_C_inferFunctionEnv x1 x2 r cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_inferFunctionEnv x1 x2 z cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((d_C_inferFunctionEnv x1 x2 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.inferFunctionEnv" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.inferFunctionEnv" (showCons x3))

nd_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
nd_C_inferFunctionEnv x1 x2 x3 s cd cs = case x3 of
     (Curry_FlatCurry.C_Prog x4 x5 x6 x7 x8) -> let
          s4 = s
           in (seq s4 (let
               s3 = leftSupply s4
               s2 = rightSupply s4
                in (seq s3 (seq s2 (nd_C__case_18 x7 x2 x1 (let
                    s1 = leftSupply s2
                    s0 = rightSupply s2
                     in (seq s1 (seq s0 (Curry_Prelude.nd_C_apply (let
                          in (Curry_List.nd_C_find (wrapDX id (d_OP_inferFunctionEnv_dot_hasName_dot_20 x2)) s0 cd cs)) x7 s1 cd cs)))) s3 cd cs)))))
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (nd_C_inferFunctionEnv x1 x2 l s cd cs) (nd_C_inferFunctionEnv x1 x2 r s cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> nd_C_inferFunctionEnv x1 x2 z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((nd_C_inferFunctionEnv x1 x2 e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.inferFunctionEnv" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.inferFunctionEnv" (showCons x3))

d_OP_inferFunctionEnv_dot_hasName_dot_20 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 x2 cd cs = case x2 of
     (Curry_FlatCurry.C_Func x3 x4 x5 x6 x7) -> Curry_Prelude.d_OP_eq_eq x1 x3 cd cs
     (Curry_FlatCurry.Choice_C_FuncDecl d i l r) -> narrow d i (d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 l cd cs) (d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 r cd cs)
     (Curry_FlatCurry.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 z cd cs) xs
     (Curry_FlatCurry.Guard_C_FuncDecl d c e) -> guardCons d c ((d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_FuncDecl d info) -> failCons d (traceFail "Inference.inferFunctionEnv.hasName.20" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferFunctionEnv.hasName.20" (showCons x2))

d_C_lookupType :: Cover -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr
d_C_lookupType cd cs = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupType :: IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr))
nd_C_lookupType s cd cs = wrapDX (wrapNX id) (acceptCs id Curry_FiniteMap.nd_C_lookupFM)

d_C_getTypeEnv :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_C_getTypeEnv x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_extractImported x1 cd cs) (d_OP_getTypeEnv_dot_uscore_hash_lambda5 x1) cd cs

nd_C_getTypeEnv :: Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_C_getTypeEnv x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.nd_OP_gt_gt_eq (d_C_extractImported x1 cd cs) (wrapNX id (nd_OP_getTypeEnv_dot_uscore_hash_lambda5 x1)) s0 cd cs)))

d_OP_getTypeEnv_dot_uscore_hash_lambda5 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_getTypeEnv_dot_uscore_hash_lambda5 x1 x2 cd cs = Curry_Prelude.d_C_return (d_C_extractKnownTypes (Curry_Prelude.OP_Cons x1 x2) cd cs) cd cs

nd_OP_getTypeEnv_dot_uscore_hash_lambda5 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_OP_getTypeEnv_dot_uscore_hash_lambda5 x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.d_C_return (let
                in (nd_C_extractKnownTypes (Curry_Prelude.OP_Cons x1 x2) s0 cd cs)) cd cs)))

d_C_extractImported :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_C_extractImported x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO Curry_FlatCurry.d_C_readFlatCurryInt cd cs) x3 cd cs
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (d_C_extractImported l cd cs) (d_C_extractImported r cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_extractImported z cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((d_C_extractImported e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.extractImported" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.extractImported" (showCons x1))

d_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_C_getTypeEnvFromProgEnv x1 x2 cd cs = case x2 of
     (Curry_FlatCurry.C_Prog x3 x4 x5 x6 x7) -> d_C__case_17 x4 x1 x2 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (d_C_getTypeEnvFromProgEnv x1 l cd cs) (d_C_getTypeEnvFromProgEnv x1 r cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_getTypeEnvFromProgEnv x1 z cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((d_C_getTypeEnvFromProgEnv x1 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.getTypeEnvFromProgEnv" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.getTypeEnvFromProgEnv" (showCons x2))

nd_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_C_getTypeEnvFromProgEnv x1 x2 s cd cs = case x2 of
     (Curry_FlatCurry.C_Prog x3 x4 x5 x6 x7) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C__case_17 x4 x1 x2 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 cd cs) s0 cd cs)))
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (nd_C_getTypeEnvFromProgEnv x1 l s cd cs) (nd_C_getTypeEnvFromProgEnv x1 r s cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> nd_C_getTypeEnvFromProgEnv x1 z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((nd_C_getTypeEnvFromProgEnv x1 e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.getTypeEnvFromProgEnv" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.getTypeEnvFromProgEnv" (showCons x2))

d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x2 cd cs = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.C_Right Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> d_C__case_16 x1 x3 x4 (Curry_Prelude.d_C_lookup x3 x1 cd cs) cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 l cd cs) (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "Inference.getTypeEnvFromProgEnv.extract.47" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.getTypeEnvFromProgEnv.extract.47" (showCons x2))

d_C_extractKnownTypes :: Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_C_extractKnownTypes x1 cd cs = Curry_Prelude.d_C_apply (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap d_OP_extractKnownTypes_dot_extractProg_dot_65 cd cs) x1 cd cs) cd cs

nd_C_extractKnownTypes :: Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
nd_C_extractKnownTypes x1 s cd cs = let
     s5 = s
      in (seq s5 (let
          s4 = leftSupply s5
          s6 = rightSupply s5
          s0 = leftSupply s6
          s3 = rightSupply s6
           in (seq s4 (seq s6 (seq s0 (seq s3 (Curry_Prelude.nd_C_apply (let
                in (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s0 cd cs)) (let
               s2 = leftSupply s3
               s1 = rightSupply s3
                in (seq s2 (seq s1 (Curry_Prelude.nd_C_apply (let
                     in (Curry_Prelude.nd_C_concatMap (wrapDX id d_OP_extractKnownTypes_dot_extractProg_dot_65) s1 cd cs)) x1 s2 cd cs)))) s4 cd cs)))))))

d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 :: Curry_FlatCurry.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> Curry_Prelude.OP_Tuple2 x2 x5
     (Curry_FlatCurry.Choice_C_FuncDecl d i l r) -> narrow d i (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 l cd cs) (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 r cd cs)
     (Curry_FlatCurry.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 z cd cs) xs
     (Curry_FlatCurry.Guard_C_FuncDecl d c e) -> guardCons d c ((d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_FuncDecl d info) -> failCons d (traceFail "Inference.extractKnownTypes.extractFuncDecl.65" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.extractKnownTypes.extractFuncDecl.65" (showCons x1))

d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_ConsDecl -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 x2 cd cs = case x2 of
     (Curry_FlatCurry.C_Cons x3 x4 x5 x6) -> Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.d_C_foldr (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType) x1 x6 cd cs)
     (Curry_FlatCurry.Choice_C_ConsDecl d i l r) -> narrow d i (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 l cd cs) (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 r cd cs)
     (Curry_FlatCurry.Choices_C_ConsDecl d i xs) -> narrows cs d i (\z -> d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 z cd cs) xs
     (Curry_FlatCurry.Guard_C_ConsDecl d c e) -> guardCons d c ((d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_ConsDecl d info) -> failCons d (traceFail "Inference.extractKnownTypes.extractConsDecl.65" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.extractKnownTypes.extractConsDecl.65" (showCons x2))

d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 :: Curry_FlatCurry.C_TypeDecl -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x1 cd cs = case x1 of
     (Curry_FlatCurry.C_TypeSyn x2 x3 x4 x5) -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 x5) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Type x6 x7 x8 x9) -> let
          x10 = Curry_FlatCurry.C_TCons x6 (Curry_Prelude.d_C_map (acceptCs id Curry_FlatCurry.C_TVar) x8 cd cs)
           in (Curry_Prelude.d_C_map (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x10) x9 cd cs)
     (Curry_FlatCurry.Choice_C_TypeDecl d i l r) -> narrow d i (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 l cd cs) (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 r cd cs)
     (Curry_FlatCurry.Choices_C_TypeDecl d i xs) -> narrows cs d i (\z -> d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeDecl d c e) -> guardCons d c ((d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeDecl d info) -> failCons d (traceFail "Inference.extractKnownTypes.extractTypeDecl.65" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.extractKnownTypes.extractTypeDecl.65" (showCons x1))

d_OP_extractKnownTypes_dot_extractProg_dot_65 :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractProg_dot_65 x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 cd cs) x4 cd cs) (Curry_Prelude.d_C_map d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x5 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (d_OP_extractKnownTypes_dot_extractProg_dot_65 l cd cs) (d_OP_extractKnownTypes_dot_extractProg_dot_65 r cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_OP_extractKnownTypes_dot_extractProg_dot_65 z cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((d_OP_extractKnownTypes_dot_extractProg_dot_65 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.extractKnownTypes.extractProg.65" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.extractKnownTypes.extractProg.65" (showCons x1))

d_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
d_C_initTIM x1 cd cs = Curry_Prelude.OP_Tuple3 x1 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)

nd_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
nd_C_initTIM x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.OP_Tuple3 x1 (Curry_Prelude.C_Int 0#) (let
                in (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s0 cd cs)))))

d_C_nextTVar :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_nextTVar cd cs = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets d_OP_nextTVar_dot_uscore_hash_lambda9

nd_C_nextTVar :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_nextTVar s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id nd_OP_nextTVar_dot_uscore_hash_lambda9))

d_OP_nextTVar_dot_uscore_hash_lambda9 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_nextTVar_dot_uscore_hash_lambda9 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple3 x2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) x4)) (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3)) cd cs
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_nextTVar_dot_uscore_hash_lambda9 l cd cs) (d_OP_nextTVar_dot_uscore_hash_lambda9 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_nextTVar_dot_uscore_hash_lambda9 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_nextTVar_dot_uscore_hash_lambda9 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.nextTVar._#lambda9" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.nextTVar._#lambda9" (showCons x1))

nd_OP_nextTVar_dot_uscore_hash_lambda9 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_nextTVar_dot_uscore_hash_lambda9 x1 s cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_ErrorState.nd_OP_gt_plus (wrapDX id (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple3 x2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) x4))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3))) s0 cd cs)))
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (nd_OP_nextTVar_dot_uscore_hash_lambda9 l s cd cs) (nd_OP_nextTVar_dot_uscore_hash_lambda9 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> nd_OP_nextTVar_dot_uscore_hash_lambda9 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((nd_OP_nextTVar_dot_uscore_hash_lambda9 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.nextTVar._#lambda9" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.nextTVar._#lambda9" (showCons x1))

d_C_initVar2TVar :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_initVar2TVar cd cs = Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_modify) d_OP_initVar2TVar_dot_uscore_hash_lambda10 cd cs

nd_C_initVar2TVar :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_initVar2TVar s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id Curry_ErrorState.nd_C_modify)) (wrapNX id nd_OP_initVar2TVar_dot_uscore_hash_lambda10) s0 cd cs)))

d_OP_initVar2TVar_dot_uscore_hash_lambda10 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM t0 t1)
d_OP_initVar2TVar_dot_uscore_hash_lambda10 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> Curry_Prelude.OP_Tuple3 x2 x3 (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_initVar2TVar_dot_uscore_hash_lambda10 l cd cs) (d_OP_initVar2TVar_dot_uscore_hash_lambda10 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_initVar2TVar_dot_uscore_hash_lambda10 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_initVar2TVar_dot_uscore_hash_lambda10 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.initVar2TVar._#lambda10" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.initVar2TVar._#lambda10" (showCons x1))

nd_OP_initVar2TVar_dot_uscore_hash_lambda10 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM t0 t1)
nd_OP_initVar2TVar_dot_uscore_hash_lambda10 x1 s cd cs = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.OP_Tuple3 x2 x3 (let
                     in (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s0 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (nd_OP_initVar2TVar_dot_uscore_hash_lambda10 l s cd cs) (nd_OP_initVar2TVar_dot_uscore_hash_lambda10 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> nd_OP_initVar2TVar_dot_uscore_hash_lambda10 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((nd_OP_initVar2TVar_dot_uscore_hash_lambda10 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.initVar2TVar._#lambda10" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.initVar2TVar._#lambda10" (showCons x1))

d_C_insertVar2TVar :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_insertVar2TVar x1 x2 cd cs = Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_modify) (d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x2 x1) cd cs

nd_C_insertVar2TVar :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_insertVar2TVar x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id Curry_ErrorState.nd_C_modify)) (wrapNX id (nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x2 x1)) s0 cd cs)))

d_OP_insertVar2TVar_dot_uscore_hash_lambda11 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Tuple3 x4 x5 x6) -> Curry_Prelude.OP_Tuple3 x4 x5 (Curry_FiniteMap.d_C_addToFM x6 x2 x1 cd cs)
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 l cd cs) (d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.insertVar2TVar._#lambda11" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.insertVar2TVar._#lambda11" (showCons x3))

nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 x3 s cd cs = case x3 of
     (Curry_Prelude.OP_Tuple3 x4 x5 x6) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.OP_Tuple3 x4 x5 (let
                     in (Curry_FiniteMap.nd_C_addToFM x6 x2 x1 s0 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 l s cd cs) (nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((nd_OP_insertVar2TVar_dot_uscore_hash_lambda11 x1 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.insertVar2TVar._#lambda11" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.insertVar2TVar._#lambda11" (showCons x3))

d_C_insertFreshVar :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_insertFreshVar x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd cs) (d_C_insertVar2TVar x1)

nd_C_insertFreshVar :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_insertFreshVar x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                in (nd_C_nextTVar s0 cd cs)) (wrapNX id (nd_C_insertVar2TVar x1))))))

d_C_lookupVar2TVar :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_lookupVar2TVar x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1)

nd_C_lookupVar2TVar :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_lookupVar2TVar x1 s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1)))

d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) t0)
d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> Curry_ErrorState.d_C_returnES (Curry_FiniteMap.d_C_lookupFM x5 x1 cd cs)
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 l cd cs) (d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.lookupVar2TVar._#lambda12" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.lookupVar2TVar._#lambda12" (showCons x2))

nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> let
          s0 = s
           in (seq s0 (let
                in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                     in (Curry_FiniteMap.nd_C_lookupFM x5 x1 s0 cd cs))))))
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 l s cd cs) (nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((nd_OP_lookupVar2TVar_dot_uscore_hash_lambda12 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.lookupVar2TVar._#lambda12" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.lookupVar2TVar._#lambda12" (showCons x2))

d_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_getTypeVariant x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1)

nd_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_getTypeVariant x1 s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1)))

d_OP_getTypeVariant_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> d_C__case_14 x1 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_lookupType cd cs) x3 cd cs) x1 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 l cd cs) (d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((d_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.getTypeVariant._#lambda13" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.getTypeVariant._#lambda13" (showCons x2))

nd_OP_getTypeVariant_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> let
          s6 = s
           in (seq s6 (let
               s5 = leftSupply s6
               s4 = rightSupply s6
                in (seq s5 (seq s4 (nd_C__case_14 x1 x3 (let
                    s3 = leftSupply s4
                    s2 = rightSupply s4
                     in (seq s3 (seq s2 (Curry_Prelude.nd_C_apply (let
                         s1 = leftSupply s2
                         s0 = rightSupply s2
                          in (seq s1 (seq s0 (Curry_Prelude.nd_C_apply (let
                               in (nd_C_lookupType s0 cd cs)) x3 s1 cd cs)))) x1 s3 cd cs)))) s5 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple3 d i l r) -> narrow d i (nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 l s cd cs) (nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple3 d i xs) -> narrows cs d i (\z -> nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple3 d c e) -> guardCons d c ((nd_OP_getTypeVariant_dot_uscore_hash_lambda13 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple3 d info) -> failCons d (traceFail "Inference.getTypeVariant._#lambda13" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.getTypeVariant._#lambda13" (showCons x2))

d_OP_getTypeVariant_dot_uscore_hash_lambda13_dot_uscore_hash_lambda15 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_getTypeVariant_dot_uscore_hash_lambda13_dot_uscore_hash_lambda15 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

d_C_freshVariant :: Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_freshVariant x1 cd cs = Curry_ErrorState.d_C_liftES Curry_Prelude.d_C_snd (d_OP_freshVariant_dot_rename_dot_120 Curry_Prelude.OP_List x1 cd cs) cd cs

nd_C_freshVariant :: Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_freshVariant x1 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id Curry_Prelude.d_C_snd) (let
                in (nd_OP_freshVariant_dot_rename_dot_120 Curry_Prelude.OP_List x1 s0 cd cs)) s1 cd cs)))))

d_OP_freshVariant_dot_rename_dot_120 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_120 x1 x2 cd cs = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> d_C__case_13 x1 x3 (Curry_Prelude.d_C_lookup x3 x1 cd cs) cd cs
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_OP_freshVariant_dot_rename_dot_120 x1 x5 cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x6)
     (Curry_FlatCurry.C_TCons x7 x8) -> Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapAccumES (acceptCs id d_OP_freshVariant_dot_rename_dot_120) x1 x8 cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x7)
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (d_OP_freshVariant_dot_rename_dot_120 x1 l cd cs) (d_OP_freshVariant_dot_rename_dot_120 x1 r cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_OP_freshVariant_dot_rename_dot_120 x1 z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((d_OP_freshVariant_dot_rename_dot_120 x1 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.freshVariant.rename.120" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120" (showCons x2))

nd_OP_freshVariant_dot_rename_dot_120 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_120 x1 x2 s cd cs = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C__case_13 x1 x3 (Curry_Prelude.d_C_lookup x3 x1 cd cs) s0 cd cs)))
     (Curry_FlatCurry.C_FuncType x5 x6) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_OP_freshVariant_dot_rename_dot_120 x1 x5 s0 cd cs)) (wrapNX id (nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x6))))))
     (Curry_FlatCurry.C_TCons x7 x8) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (Curry_ErrorState.nd_C_mapAccumES (wrapDX (wrapNX id) (acceptCs id nd_OP_freshVariant_dot_rename_dot_120)) x1 x8 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x7))))))
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (nd_OP_freshVariant_dot_rename_dot_120 x1 l s cd cs) (nd_OP_freshVariant_dot_rename_dot_120 x1 r s cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> nd_OP_freshVariant_dot_rename_dot_120 x1 z s cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((nd_OP_freshVariant_dot_rename_dot_120 x1 e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.freshVariant.rename.120" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120" (showCons x2))

d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda17 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda17 x1 x2 x3 cd cs = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1 x3) x2) x3)

d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_OP_gt_plus_eq (d_OP_freshVariant_dot_rename_dot_120 x3 x1 cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x4)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 l cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.freshVariant.rename.120._#lambda18" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120._#lambda18" (showCons x2))

nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_OP_freshVariant_dot_rename_dot_120 x3 x1 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x4))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 l s cd cs) (nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.freshVariant.rename.120._#lambda18" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120._#lambda18" (showCons x2))

d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_FuncType x1 x4))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 l cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda18_dot_uscore_hash_lambda19 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.freshVariant.rename.120._#lambda18._#lambda19" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120._#lambda18._#lambda19" (showCons x2))

d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_TCons x1 x4))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x1 l cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda20 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.freshVariant.rename.120._#lambda20" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.freshVariant.rename.120._#lambda20" (showCons x2))

d_OP_plus_plus_eq :: Curry_Prelude.Curry t0 => Cover -> ConstStore -> (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))) -> Cover -> ConstStore -> (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_plus_plus_eq cd cs = acceptCs id (Curry_ErrorState.d_C_liftES2 (acceptCs id Curry_Prelude.d_OP_plus_plus))

nd_OP_plus_plus_eq :: Curry_Prelude.Curry t0 => IDSupply -> Cover -> ConstStore -> Func (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))) (Func (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))) (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))))
nd_OP_plus_plus_eq s cd cs = wrapDX (wrapNX id) (acceptCs id (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_plus_plus))))

d_C_annProg :: Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annProg x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_annProg_dot_uscore_hash_lambda21 x3 x2 x6 x4) (Curry_ErrorState.d_C_mapES d_C_annFunc x5 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (d_C_annProg l cd cs) (d_C_annProg r cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> d_C_annProg z cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((d_C_annProg e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.annProg" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annProg" (showCons x1))

nd_C_annProg :: Curry_FlatCurry.C_Prog -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annProg x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annProg_dot_uscore_hash_lambda21 x3 x2 x6 x4)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annFunc) x5 s0 cd cs)) s1 cd cs)))))
     (Curry_FlatCurry.Choice_C_Prog d i l r) -> narrow d i (nd_C_annProg l s cd cs) (nd_C_annProg r s cd cs)
     (Curry_FlatCurry.Choices_C_Prog d i xs) -> narrows cs d i (\z -> nd_C_annProg z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Prog d c e) -> guardCons d c ((nd_C_annProg e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Prog d info) -> failCons d (traceFail "Inference.annProg" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annProg" (showCons x1))

d_OP_annProg_dot_uscore_hash_lambda21 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_FlatCurry.C_OpDecl -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr
d_OP_annProg_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 cd cs = Curry_AnnotatedFlatCurry.C_AProg x2 x1 x4 x5 x3

d_C_annFunc :: Curry_FlatCurry.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annFunc x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> Curry_ErrorState.d_OP_gt_plus (d_C_initVar2TVar cd cs) (Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4)) (d_C_freshVariant x5 cd cs) (d_C_annRule x6 cd cs) cd cs) cd cs
     (Curry_FlatCurry.Choice_C_FuncDecl d i l r) -> narrow d i (d_C_annFunc l cd cs) (d_C_annFunc r cd cs)
     (Curry_FlatCurry.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> d_C_annFunc z cd cs) xs
     (Curry_FlatCurry.Guard_C_FuncDecl d c e) -> guardCons d c ((d_C_annFunc e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_FuncDecl d info) -> failCons d (traceFail "Inference.annFunc" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annFunc" (showCons x1))

nd_C_annFunc :: Curry_FlatCurry.C_FuncDecl -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annFunc x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> let
          s7 = s
           in (seq s7 (let
               s6 = leftSupply s7
               s8 = rightSupply s7
               s0 = leftSupply s8
               s4 = rightSupply s8
                in (seq s6 (seq s8 (seq s0 (seq s4 (Curry_ErrorState.nd_OP_gt_plus (let
                     in (nd_C_initVar2TVar s0 cd cs)) (let
                    s3 = leftSupply s4
                    s5 = rightSupply s4
                    s1 = leftSupply s5
                    s2 = rightSupply s5
                     in (seq s3 (seq s5 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4))) (let
                          in (nd_C_freshVariant x5 s1 cd cs)) (let
                          in (nd_C_annRule x6 s2 cd cs)) s3 cd cs)))))) s6 cd cs)))))))
     (Curry_FlatCurry.Choice_C_FuncDecl d i l r) -> narrow d i (nd_C_annFunc l s cd cs) (nd_C_annFunc r s cd cs)
     (Curry_FlatCurry.Choices_C_FuncDecl d i xs) -> narrows cs d i (\z -> nd_C_annFunc z s cd cs) xs
     (Curry_FlatCurry.Guard_C_FuncDecl d c e) -> guardCons d c ((nd_C_annFunc e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_FuncDecl d info) -> failCons d (traceFail "Inference.annFunc" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annFunc" (showCons x1))

d_C_annRule :: Curry_FlatCurry.C_Rule -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annRule x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Rule x2 x3) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule) (d_C_nextTVar cd cs) (Curry_ErrorState.d_C_mapES d_C_annVar x2 cd cs) (d_C_annExpr x3 cd cs) cd cs
     (Curry_FlatCurry.C_External x4) -> Curry_ErrorState.d_C_liftES (d_OP_annRule_dot_uscore_hash_lambda22 x4) (d_C_nextTVar cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Rule d i l r) -> narrow d i (d_C_annRule l cd cs) (d_C_annRule r cd cs)
     (Curry_FlatCurry.Choices_C_Rule d i xs) -> narrows cs d i (\z -> d_C_annRule z cd cs) xs
     (Curry_FlatCurry.Guard_C_Rule d c e) -> guardCons d c ((d_C_annRule e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Rule d info) -> failCons d (traceFail "Inference.annRule" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annRule" (showCons x1))

nd_C_annRule :: Curry_FlatCurry.C_Rule -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annRule x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Rule x2 x3) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annVar) x2 s1 cd cs)) (let
                     in (nd_C_annExpr x3 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_External x4) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annRule_dot_uscore_hash_lambda22 x4)) (let
                     in (nd_C_nextTVar s0 cd cs)) s1 cd cs)))))
     (Curry_FlatCurry.Choice_C_Rule d i l r) -> narrow d i (nd_C_annRule l s cd cs) (nd_C_annRule r s cd cs)
     (Curry_FlatCurry.Choices_C_Rule d i xs) -> narrows cs d i (\z -> nd_C_annRule z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Rule d c e) -> guardCons d c ((nd_C_annRule e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Rule d info) -> failCons d (traceFail "Inference.annRule" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annRule" (showCons x1))

d_OP_annRule_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
d_OP_annRule_dot_uscore_hash_lambda22 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_AExternal x2 x1

d_C_annExpr :: Curry_FlatCurry.C_Expr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annExpr x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Var x2) -> let
          x3 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List))))))))))))))))))))))))))))) cd cs) cd cs
           in (Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVar2TVar x2 cd cs) (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_failES x3) (d_OP_annExpr_dot_uscore_hash_lambda23 x2)))
     (Curry_FlatCurry.C_Lit x4) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd cs) (d_OP_annExpr_dot_uscore_hash_lambda24 x4)
     (Curry_FlatCurry.C_Comb x5 x6 x7) -> Curry_ErrorState.d_C_liftES3 (d_OP_annExpr_dot_uscore_hash_lambda25 x5) (d_C_nextTVar cd cs) (d_C_getTypeVariant x6 cd cs) (Curry_ErrorState.d_C_mapES d_C_annExpr x7 cd cs) cd cs
     (Curry_FlatCurry.C_Case x8 x9 x10) -> Curry_ErrorState.d_C_liftES3 (d_OP_annExpr_dot_uscore_hash_lambda26 x8) (d_C_nextTVar cd cs) (d_C_annExpr x9 cd cs) (Curry_ErrorState.d_C_mapES d_C_annBranch x10 cd cs) cd cs
     (Curry_FlatCurry.C_Or x11 x12) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr) (d_C_nextTVar cd cs) (d_C_annExpr x11 cd cs) (d_C_annExpr x12 cd cs) cd cs
     (Curry_FlatCurry.C_Let x13 x14) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet) (d_C_nextTVar cd cs) (d_OP_annExpr_dot_annBindings_dot_163 x13 cd cs) (d_C_annExpr x14 cd cs) cd cs
     (Curry_FlatCurry.C_Free x15 x16) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree) (d_C_nextTVar cd cs) (Curry_ErrorState.d_C_mapES d_OP_annExpr_dot_annFree_dot_173 x15 cd cs) (d_C_annExpr x16 cd cs) cd cs
     (Curry_FlatCurry.C_Typed x17 x18) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped) (d_C_nextTVar cd cs) (d_C_annExpr x17 cd cs) (d_C_freshVariant x18 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Expr d i l r) -> narrow d i (d_C_annExpr l cd cs) (d_C_annExpr r cd cs)
     (Curry_FlatCurry.Choices_C_Expr d i xs) -> narrows cs d i (\z -> d_C_annExpr z cd cs) xs
     (Curry_FlatCurry.Guard_C_Expr d c e) -> guardCons d c ((d_C_annExpr e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Expr d info) -> failCons d (traceFail "Inference.annExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annExpr" (showCons x1))

nd_C_annExpr :: Curry_FlatCurry.C_Expr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annExpr x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Var x2) -> let
          s0 = s
           in (seq s0 (let
                in (let
                    x3 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List))))))))))))))))))))))))))))) cd cs) cd cs
                     in (let
                          in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                               in (nd_C_lookupVar2TVar x2 s0 cd cs)) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id (Curry_ErrorState.d_C_failES x3)) (wrapDX (wrapDX id) (d_OP_annExpr_dot_uscore_hash_lambda23 x2))))))))))
     (Curry_FlatCurry.C_Lit x4) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_nextTVar s0 cd cs)) (wrapDX (wrapDX id) (d_OP_annExpr_dot_uscore_hash_lambda24 x4))))))
     (Curry_FlatCurry.C_Comb x5 x6 x7) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (d_OP_annExpr_dot_uscore_hash_lambda25 x5)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_C_getTypeVariant x6 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x7 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_Case x8 x9 x10) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (d_OP_annExpr_dot_uscore_hash_lambda26 x8)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_C_annExpr x9 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annBranch) x10 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_Or x11 x12) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_C_annExpr x11 s1 cd cs)) (let
                     in (nd_C_annExpr x12 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_Let x13 x14) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_OP_annExpr_dot_annBindings_dot_163 x13 s1 cd cs)) (let
                     in (nd_C_annExpr x14 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_Free x15 x16) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annExpr_dot_annFree_dot_173) x15 s1 cd cs)) (let
                     in (nd_C_annExpr x16 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_Typed x17 x18) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_C_annExpr x17 s1 cd cs)) (let
                     in (nd_C_freshVariant x18 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.Choice_C_Expr d i l r) -> narrow d i (nd_C_annExpr l s cd cs) (nd_C_annExpr r s cd cs)
     (Curry_FlatCurry.Choices_C_Expr d i xs) -> narrows cs d i (\z -> nd_C_annExpr z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Expr d c e) -> guardCons d c ((nd_C_annExpr e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Expr d info) -> failCons d (traceFail "Inference.annExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annExpr" (showCons x1))

d_OP_annExpr_dot_uscore_hash_lambda23 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0)
d_OP_annExpr_dot_uscore_hash_lambda23 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_AVar x2 x1)

d_OP_annExpr_dot_uscore_hash_lambda24 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0)
d_OP_annExpr_dot_uscore_hash_lambda24 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_ALit x2 x1)

d_OP_annExpr_dot_uscore_hash_lambda25 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_annExpr_dot_uscore_hash_lambda25 x1 x2 cd cs = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1)

d_OP_annExpr_dot_uscore_hash_lambda26 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_annExpr_dot_uscore_hash_lambda26 x1 x2 cd cs = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1)

d_OP_annExpr_dot_checkVar_dot_163 :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_checkVar_dot_163 x1 cd cs = Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 cd cs) (d_C_insertFreshVar x1 cd cs) cd cs) (Curry_ErrorState.d_C_returnES x1) cd cs

nd_OP_annExpr_dot_checkVar_dot_163 :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_checkVar_dot_163 x1 s cd cs = let
     s6 = s
      in (seq s6 (let
          s5 = leftSupply s6
          s3 = rightSupply s6
           in (seq s5 (seq s3 (Curry_ErrorState.nd_OP_gt_plus (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_OP_gt_plus (let
                     in (nd_C_checkShadowing x1 s0 cd cs)) (let
                     in (nd_C_insertFreshVar x1 s1 cd cs)) s2 cd cs)))))) (wrapDX id (Curry_ErrorState.d_C_returnES x1)) s5 cd cs)))))

d_OP_annExpr_dot_annBindings_dot_163 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_Expr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_163 x1 cd cs = let
     x2 = Curry_Prelude.d_C_unzip x1 cd cs
     x3 = d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs x2 cd cs
     x4 = d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es x2 cd cs
      in (Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES d_OP_annExpr_dot_checkVar_dot_163 x3 cd cs) (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 x4))

nd_OP_annExpr_dot_annBindings_dot_163 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_Expr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_163 x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (let
               x2 = Curry_Prelude.d_C_unzip x1 cd cs
               x3 = d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs x2 cd cs
               x4 = d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es x2 cd cs
                in (let
                     in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                          in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annExpr_dot_checkVar_dot_163) x3 s0 cd cs)) (wrapNX id (nd_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 x4))))))))

d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List Curry_FlatCurry.C_Expr) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs l cd cs) (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP2_hash_vs e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.annExpr.annBindings.163._#selFP2#vs" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annExpr.annBindings.163._#selFP2#vs" (showCons x1))

d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List Curry_FlatCurry.C_Expr) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_Expr
d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es l cd cs) (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_selFP3_hash_es e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.annExpr.annBindings.163._#selFP3#es" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annExpr.annBindings.163._#selFP3#es" (showCons x1))

d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 :: Curry_Prelude.OP_List Curry_FlatCurry.C_Expr -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 x1 x2 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES d_C_annExpr x1 cd cs) (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x2)

nd_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 :: Curry_Prelude.OP_List Curry_FlatCurry.C_Expr -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27 x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x1 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x2))))))

d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) t0)
d_OP_annExpr_dot_annBindings_dot_163_dot_uscore_hash_lambda27_dot_uscore_hash_lambda28 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_Prelude.d_C_zip x1 x2 cd cs)

d_OP_annExpr_dot_annFree_dot_173 :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annFree_dot_173 x1 cd cs = Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 cd cs) (d_C_annVar x1 cd cs) cd cs

nd_OP_annExpr_dot_annFree_dot_173 :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annFree_dot_173 x1 s cd cs = let
     s3 = s
      in (seq s3 (let
          s2 = leftSupply s3
          s4 = rightSupply s3
          s0 = leftSupply s4
          s1 = rightSupply s4
           in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_OP_gt_plus (let
                in (nd_C_checkShadowing x1 s0 cd cs)) (let
                in (nd_C_annVar x1 s1 cd cs)) s2 cd cs)))))))

d_C_annVar :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annVar x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd cs) (d_OP_annVar_dot_uscore_hash_lambda29 x1)

nd_C_annVar :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annVar x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                in (nd_C_nextTVar s0 cd cs)) (wrapNX id (nd_OP_annVar_dot_uscore_hash_lambda29 x1))))))

d_OP_annVar_dot_uscore_hash_lambda29 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annVar_dot_uscore_hash_lambda29 x1 x2 cd cs = Curry_ErrorState.d_OP_gt_plus (d_C_insertVar2TVar x1 x2 cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)) cd cs

nd_OP_annVar_dot_uscore_hash_lambda29 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annVar_dot_uscore_hash_lambda29 x1 x2 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_ErrorState.nd_OP_gt_plus (let
                in (nd_C_insertVar2TVar x1 x2 s0 cd cs)) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2))) s1 cd cs)))))

d_C_checkShadowing :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_checkShadowing x1 cd cs = let
     x2 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x1 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List)))))))))) cd cs) cd cs
      in (Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVar2TVar x1 cd cs) (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit) (d_OP_checkShadowing_dot_uscore_hash_lambda30 x2)))

nd_C_checkShadowing :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_checkShadowing x1 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (let
               x2 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x1 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List)))))))))) cd cs) cd cs
                in (let
                     in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                          in (nd_C_lookupVar2TVar x1 s0 cd cs)) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit)) (wrapDX (wrapDX id) (d_OP_checkShadowing_dot_uscore_hash_lambda30 x2))))))))))

d_OP_checkShadowing_dot_uscore_hash_lambda30 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_checkShadowing_dot_uscore_hash_lambda30 x1 x2 cd cs = Curry_ErrorState.d_C_failES x1

d_C_annBranch :: Curry_FlatCurry.C_BranchExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annBranch x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Branch x2 x3) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch) (d_C_annPattern x2 cd cs) (d_C_annExpr x3 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_BranchExpr d i l r) -> narrow d i (d_C_annBranch l cd cs) (d_C_annBranch r cd cs)
     (Curry_FlatCurry.Choices_C_BranchExpr d i xs) -> narrows cs d i (\z -> d_C_annBranch z cd cs) xs
     (Curry_FlatCurry.Guard_C_BranchExpr d c e) -> guardCons d c ((d_C_annBranch e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_BranchExpr d info) -> failCons d (traceFail "Inference.annBranch" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annBranch" (showCons x1))

nd_C_annBranch :: Curry_FlatCurry.C_BranchExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annBranch x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Branch x2 x3) -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch)) (let
                     in (nd_C_annPattern x2 s0 cd cs)) (let
                     in (nd_C_annExpr x3 s1 cd cs)) s2 cd cs)))))))
     (Curry_FlatCurry.Choice_C_BranchExpr d i l r) -> narrow d i (nd_C_annBranch l s cd cs) (nd_C_annBranch r s cd cs)
     (Curry_FlatCurry.Choices_C_BranchExpr d i xs) -> narrows cs d i (\z -> nd_C_annBranch z s cd cs) xs
     (Curry_FlatCurry.Guard_C_BranchExpr d c e) -> guardCons d c ((nd_C_annBranch e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_BranchExpr d info) -> failCons d (traceFail "Inference.annBranch" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annBranch" (showCons x1))

d_C_annPattern :: Curry_FlatCurry.C_Pattern -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annPattern x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Pattern x2 x3) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern) (d_C_nextTVar cd cs) (d_C_getTypeVariant x2 cd cs) (Curry_ErrorState.d_C_mapES d_OP_annPattern_dot_annPVar_dot_189 x3 cd cs) cd cs
     (Curry_FlatCurry.C_LPattern x4) -> Curry_ErrorState.d_C_liftES (d_OP_annPattern_dot_uscore_hash_lambda31 x4) (d_C_nextTVar cd cs) cd cs
     (Curry_FlatCurry.Choice_C_Pattern d i l r) -> narrow d i (d_C_annPattern l cd cs) (d_C_annPattern r cd cs)
     (Curry_FlatCurry.Choices_C_Pattern d i xs) -> narrows cs d i (\z -> d_C_annPattern z cd cs) xs
     (Curry_FlatCurry.Guard_C_Pattern d c e) -> guardCons d c ((d_C_annPattern e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Pattern d info) -> failCons d (traceFail "Inference.annPattern" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annPattern" (showCons x1))

nd_C_annPattern :: Curry_FlatCurry.C_Pattern -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annPattern x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_Pattern x2 x3) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern)) (let
                     in (nd_C_nextTVar s0 cd cs)) (let
                     in (nd_C_getTypeVariant x2 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annPattern_dot_annPVar_dot_189) x3 s2 cd cs)) s3 cd cs)))))))))
     (Curry_FlatCurry.C_LPattern x4) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annPattern_dot_uscore_hash_lambda31 x4)) (let
                     in (nd_C_nextTVar s0 cd cs)) s1 cd cs)))))
     (Curry_FlatCurry.Choice_C_Pattern d i l r) -> narrow d i (nd_C_annPattern l s cd cs) (nd_C_annPattern r s cd cs)
     (Curry_FlatCurry.Choices_C_Pattern d i xs) -> narrows cs d i (\z -> nd_C_annPattern z s cd cs) xs
     (Curry_FlatCurry.Guard_C_Pattern d c e) -> guardCons d c ((nd_C_annPattern e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Pattern d info) -> failCons d (traceFail "Inference.annPattern" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.annPattern" (showCons x1))

d_OP_annPattern_dot_annPVar_dot_189 :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annPattern_dot_annPVar_dot_189 x1 cd cs = Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 cd cs) (d_C_annVar x1 cd cs) cd cs

nd_OP_annPattern_dot_annPVar_dot_189 :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annPattern_dot_annPVar_dot_189 x1 s cd cs = let
     s3 = s
      in (seq s3 (let
          s2 = leftSupply s3
          s4 = rightSupply s3
          s0 = leftSupply s4
          s1 = rightSupply s4
           in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_OP_gt_plus (let
                in (nd_C_checkShadowing x1 s0 cd cs)) (let
                in (nd_C_annVar x1 s1 cd cs)) s2 cd cs)))))))

d_OP_annPattern_dot_uscore_hash_lambda31 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
d_OP_annPattern_dot_uscore_hash_lambda31 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_ALPattern x2 x1

d_C_inferAProg :: Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferAProg x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AProg x2 x3 x4 x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_inferAProg_dot_uscore_hash_lambda32 x3 x2 x6 x4) (Curry_ErrorState.d_C_mapES d_C_inferFunc x5 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_AProg d i l r) -> narrow d i (d_C_inferAProg l cd cs) (d_C_inferAProg r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AProg d i xs) -> narrows cs d i (\z -> d_C_inferAProg z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AProg d c e) -> guardCons d c ((d_C_inferAProg e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AProg d info) -> failCons d (traceFail "Inference.inferAProg" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferAProg" (showCons x1))

nd_C_inferAProg :: Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferAProg x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AProg x2 x3 x4 x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_inferAProg_dot_uscore_hash_lambda32 x3 x2 x6 x4)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_inferFunc) x5 s0 cd cs)) s1 cd cs)))))
     (Curry_AnnotatedFlatCurry.Choice_C_AProg d i l r) -> narrow d i (nd_C_inferAProg l s cd cs) (nd_C_inferAProg r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AProg d i xs) -> narrows cs d i (\z -> nd_C_inferAProg z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AProg d c e) -> guardCons d c ((nd_C_inferAProg e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AProg d info) -> failCons d (traceFail "Inference.inferAProg" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferAProg" (showCons x1))

d_OP_inferAProg_dot_uscore_hash_lambda32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_FlatCurry.C_OpDecl -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr
d_OP_inferAProg_dot_uscore_hash_lambda32 x1 x2 x3 x4 x5 cd cs = Curry_AnnotatedFlatCurry.C_AProg x2 x1 x4 x5 x3

d_C_inferFunc :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferFunc x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_inferRule x5 x6 cd cs) (d_OP_inferFunc_dot_uscore_hash_lambda33 x1)
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl d i l r) -> narrow d i (d_C_inferFunc l cd cs) (d_C_inferFunc r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl d i xs) -> narrows cs d i (\z -> d_C_inferFunc z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl d c e) -> guardCons d c ((d_C_inferFunc e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl d info) -> failCons d (traceFail "Inference.inferFunc" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferFunc" (showCons x1))

nd_C_inferFunc :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferFunc x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_inferRule x5 x6 s0 cd cs)) (wrapNX id (nd_OP_inferFunc_dot_uscore_hash_lambda33 x1))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl d i l r) -> narrow d i (nd_C_inferFunc l s cd cs) (nd_C_inferFunc r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl d i xs) -> narrows cs d i (\z -> nd_C_inferFunc z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl d c e) -> guardCons d c ((nd_C_inferFunc e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl d info) -> failCons d (traceFail "Inference.inferFunc" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferFunc" (showCons x1))

d_OP_inferFunc_dot_uscore_hash_lambda33 :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_inferFunc_dot_uscore_hash_lambda33 x1 x2 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (d_C_unification x2 cd cs) (d_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 x1)

nd_OP_inferFunc_dot_uscore_hash_lambda33 :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_inferFunc_dot_uscore_hash_lambda33 x1 x2 s cd cs = let
     s0 = s
      in (seq s0 (let
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                in (nd_C_unification x2 s0 cd cs)) (wrapNX id (nd_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 x1))))))

d_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 x1 x2 cd cs = Curry_Prelude.d_OP_dollar d_C_normFunc (Curry_AFCSubst.d_C_substFunc x2 x1 cd cs) cd cs

nd_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_inferFunc_dot_uscore_hash_lambda33_dot_uscore_hash_lambda34 x1 x2 s cd cs = let
     s2 = s
      in (seq s2 (let
          s1 = leftSupply s2
          s0 = rightSupply s2
           in (seq s1 (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) d_C_normFunc) (let
                in (Curry_AFCSubst.nd_C_substFunc x2 x1 s0 cd cs)) s1 cd cs)))))

d_OP_eq_dot_eq :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr
d_OP_eq_dot_eq x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_showTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeEqs cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unlines (Curry_Prelude.d_C_map d_OP_showTypeEqs_dot_showEquation_dot_208) cd cs

d_OP_showTypeEqs_dot_showEquation_dot_208 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showTypeEqs_dot_showEquation_dot_208 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))) (Curry_Prelude.d_C_show x3 cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_showTypeEqs_dot_showEquation_dot_208 l cd cs) (d_OP_showTypeEqs_dot_showEquation_dot_208 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_showTypeEqs_dot_showEquation_dot_208 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_showTypeEqs_dot_showEquation_dot_208 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.showTypeEqs.showEquation.208" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.showTypeEqs.showEquation.208" (showCons x1))

d_C_inferRule :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferRule x1 x2 cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 cd cs) (d_C_matchApp (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x5 cd cs) x1 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x4 cd cs) cd cs))) cd cs) (d_C_inferExpr x5 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AExternal x6 x7) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6 cd cs) Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r) -> narrow d i (d_C_inferRule x1 l cd cs) (d_C_inferRule x1 r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs) -> narrows cs d i (\z -> d_C_inferRule x1 z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ARule d c e) -> guardCons d c ((d_C_inferRule x1 e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule d info) -> failCons d (traceFail "Inference.inferRule" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferRule" (showCons x2))

nd_C_inferRule :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferRule x1 x2 s cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5) -> let
          s9 = s
           in (seq s9 (let
               s8 = leftSupply s9
               s10 = rightSupply s9
               s5 = leftSupply s10
               s7 = rightSupply s10
                in (seq s8 (seq s10 (seq s5 (seq s7 (Curry_Prelude.nd_C_apply (let
                    s4 = leftSupply s5
                    s6 = rightSupply s5
                    s0 = leftSupply s6
                    s3 = rightSupply s6
                     in (seq s4 (seq s6 (seq s0 (seq s3 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                               in (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 cd cs) (let
                                   s1 = leftSupply s3
                                   s2 = rightSupply s3
                                    in (seq s1 (seq s2 (d_C_matchApp (let
                                         in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x5 s1 cd cs)) x1 (let
                                         in (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x4 s2 cd cs)) cd cs))))))))) s4 cd cs)))))) (let
                     in (nd_C_inferExpr x5 s7 cd cs)) s8 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_AExternal x6 x7) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6 cd cs) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r) -> narrow d i (nd_C_inferRule x1 l s cd cs) (nd_C_inferRule x1 r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs) -> narrows cs d i (\z -> nd_C_inferRule x1 z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ARule d c e) -> guardCons d c ((nd_C_inferRule x1 e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule d info) -> failCons d (traceFail "Inference.inferRule" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferRule" (showCons x2))

d_C_matchApp :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C_matchApp x1 x2 x3 cd cs = case x3 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x2 cd cs) Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> d_C__case_12 x5 x1 x4 x2 cd cs
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_matchApp x1 x2 l cd cs) (d_C_matchApp x1 x2 r cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_matchApp x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_matchApp x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "Inference.matchApp" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.matchApp" (showCons x3))

d_C_inferExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferExpr x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 (d_C_literalType x5 cd cs) cd cs) Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> d_C__case_11 x9 x6 x8 cd cs
     (Curry_AnnotatedFlatCurry.C_ACase x12 x13 x14 x15) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (d_C_inferExpr x14 cd cs) cd cs) (Curry_ErrorState.d_C_concatMapES (d_C_inferBranch x12 x14) x15 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x17 cd cs) x16 cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x18 cd cs) x16 cd cs) Curry_Prelude.OP_List))) cd cs) (d_C_inferExpr x17 cd cs) cd cs) cd cs) (d_C_inferExpr x18 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          x22 = Curry_Prelude.d_C_map d_OP_inferExpr_dot_uscore_hash_lambda36 x20 cd cs
           in (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_concatMapES (d_C_inferVars x22) (Curry_Prelude.OP_Cons x21 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 cd cs)) cd cs) cd cs) (Curry_ErrorState.d_C_concatMapES d_C_inferExpr (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 cd cs) cd cs) cd cs) cd cs) (d_C_inferExpr x21 cd cs) cd cs) cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x19 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x21 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs)
     (Curry_AnnotatedFlatCurry.C_AFree x23 x24 x25) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (d_C_inferExpr x25 cd cs) cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x23 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x25 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs
     (Curry_AnnotatedFlatCurry.C_ATyped x26 x27 x28) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (d_C_inferExpr x27 cd cs) cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x27 cd cs) x26 cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x27 cd cs) x28 cd cs) Curry_Prelude.OP_List))) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (d_C_inferExpr l cd cs) (d_C_inferExpr r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> d_C_inferExpr z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((d_C_inferExpr e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.inferExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferExpr" (showCons x1))

nd_C_inferExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferExpr x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 (d_C_literalType x5 cd cs) cd cs) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C__case_11 x9 x6 x8 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.C_ACase x12 x13 x14 x15) -> let
          s7 = s
           in (seq s7 (let
               s6 = leftSupply s7
               s8 = rightSupply s7
               s3 = leftSupply s8
               s5 = rightSupply s8
                in (seq s6 (seq s8 (seq s3 (seq s5 (Curry_Prelude.nd_C_apply (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (nd_C_inferExpr x14 s1 cd cs)) s2 cd cs)))))) (let
                     in (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferBranch x12 x14)) x15 s5 cd cs)) s6 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> let
          s17 = s
           in (seq s17 (let
               s16 = leftSupply s17
               s18 = rightSupply s17
               s13 = leftSupply s18
               s15 = rightSupply s18
                in (seq s16 (seq s18 (seq s13 (seq s15 (Curry_Prelude.nd_C_apply (let
                    s12 = leftSupply s13
                    s14 = rightSupply s13
                    s0 = leftSupply s14
                    s10 = rightSupply s14
                     in (seq s12 (seq s14 (seq s0 (seq s10 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                         s9 = leftSupply s10
                         s11 = rightSupply s10
                         s6 = leftSupply s11
                         s8 = rightSupply s11
                          in (seq s9 (seq s11 (seq s6 (seq s8 (Curry_Prelude.nd_C_apply (let
                              s5 = leftSupply s6
                              s7 = rightSupply s6
                              s1 = leftSupply s7
                              s4 = rightSupply s7
                               in (seq s5 (seq s7 (seq s1 (seq s4 (Curry_Prelude.nd_C_apply (let
                                    in (nd_OP_plus_plus_eq s1 cd cs)) (let
                                    in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                                        s2 = leftSupply s4
                                        s3 = rightSupply s4
                                         in (seq s2 (seq s3 (Curry_Prelude.OP_Cons (let
                                              in (d_OP_eq_dot_eq (let
                                                   in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x17 s2 cd cs)) x16 cd cs)) (let
                                              in (Curry_Prelude.OP_Cons (let
                                                   in (d_OP_eq_dot_eq (let
                                                        in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x18 s3 cd cs)) x16 cd cs)) Curry_Prelude.OP_List))))))))) s5 cd cs)))))) (let
                               in (nd_C_inferExpr x17 s8 cd cs)) s9 cd cs)))))) s12 cd cs)))))) (let
                     in (nd_C_inferExpr x18 s15 cd cs)) s16 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          s30 = s
           in (seq s30 (let
               s0 = leftSupply s30
               s28 = rightSupply s30
                in (seq s0 (seq s28 (let
                    x22 = let
                          in (Curry_Prelude.nd_C_map (wrapDX id d_OP_inferExpr_dot_uscore_hash_lambda36) x20 s0 cd cs)
                     in (let
                         s27 = leftSupply s28
                         s29 = rightSupply s28
                         s24 = leftSupply s29
                         s26 = rightSupply s29
                          in (seq s27 (seq s29 (seq s24 (seq s26 (Curry_Prelude.nd_C_apply (let
                              s23 = leftSupply s24
                              s25 = rightSupply s24
                              s1 = leftSupply s25
                              s21 = rightSupply s25
                               in (seq s23 (seq s25 (seq s1 (seq s21 (Curry_Prelude.nd_C_apply (let
                                    in (nd_OP_plus_plus_eq s1 cd cs)) (let
                                   s20 = leftSupply s21
                                   s22 = rightSupply s21
                                   s17 = leftSupply s22
                                   s19 = rightSupply s22
                                    in (seq s20 (seq s22 (seq s17 (seq s19 (Curry_Prelude.nd_C_apply (let
                                        s16 = leftSupply s17
                                        s18 = rightSupply s17
                                        s2 = leftSupply s18
                                        s14 = rightSupply s18
                                         in (seq s16 (seq s18 (seq s2 (seq s14 (Curry_Prelude.nd_C_apply (let
                                              in (nd_OP_plus_plus_eq s2 cd cs)) (let
                                             s13 = leftSupply s14
                                             s15 = rightSupply s14
                                             s8 = leftSupply s15
                                             s12 = rightSupply s15
                                              in (seq s13 (seq s15 (seq s8 (seq s12 (Curry_Prelude.nd_C_apply (let
                                                  s7 = leftSupply s8
                                                  s9 = rightSupply s8
                                                  s3 = leftSupply s9
                                                  s6 = rightSupply s9
                                                   in (seq s7 (seq s9 (seq s3 (seq s6 (Curry_Prelude.nd_C_apply (let
                                                        in (nd_OP_plus_plus_eq s3 cd cs)) (let
                                                       s5 = leftSupply s6
                                                       s4 = rightSupply s6
                                                        in (seq s5 (seq s4 (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x22)) (let
                                                             in (Curry_Prelude.OP_Cons x21 (let
                                                                  in (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 s4 cd cs)))) s5 cd cs)))) s7 cd cs)))))) (let
                                                  s11 = leftSupply s12
                                                  s10 = rightSupply s12
                                                   in (seq s11 (seq s10 (Curry_ErrorState.nd_C_concatMapES (wrapNX id nd_C_inferExpr) (let
                                                        in (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 s10 cd cs)) s11 cd cs)))) s13 cd cs)))))) s16 cd cs)))))) (let
                                         in (nd_C_inferExpr x21 s19 cd cs)) s20 cd cs)))))) s23 cd cs)))))) (let
                               in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                                    in (Curry_Prelude.OP_Cons (let
                                         in (d_OP_eq_dot_eq x19 (let
                                              in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x21 s26 cd cs)) cd cs)) Curry_Prelude.OP_List))))) s27 cd cs)))))))))))
     (Curry_AnnotatedFlatCurry.C_AFree x23 x24 x25) -> let
          s7 = s
           in (seq s7 (let
               s6 = leftSupply s7
               s8 = rightSupply s7
               s3 = leftSupply s8
               s5 = rightSupply s8
                in (seq s6 (seq s8 (seq s3 (seq s5 (Curry_Prelude.nd_C_apply (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (nd_C_inferExpr x25 s1 cd cs)) s2 cd cs)))))) (let
                     in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                          in (Curry_Prelude.OP_Cons (let
                               in (d_OP_eq_dot_eq x23 (let
                                    in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x25 s5 cd cs)) cd cs)) Curry_Prelude.OP_List))))) s6 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_ATyped x26 x27 x28) -> let
          s9 = s
           in (seq s9 (let
               s8 = leftSupply s9
               s10 = rightSupply s9
               s3 = leftSupply s10
               s7 = rightSupply s10
                in (seq s8 (seq s10 (seq s3 (seq s7 (Curry_Prelude.nd_C_apply (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (nd_C_inferExpr x27 s1 cd cs)) s2 cd cs)))))) (let
                     in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                         s5 = leftSupply s7
                         s6 = rightSupply s7
                          in (seq s5 (seq s6 (Curry_Prelude.OP_Cons (let
                               in (d_OP_eq_dot_eq (let
                                    in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x27 s5 cd cs)) x26 cd cs)) (let
                               in (Curry_Prelude.OP_Cons (let
                                    in (d_OP_eq_dot_eq (let
                                         in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x27 s6 cd cs)) x28 cd cs)) Curry_Prelude.OP_List))))))))) s8 cd cs)))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (nd_C_inferExpr l s cd cs) (nd_C_inferExpr r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> nd_C_inferExpr z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((nd_C_inferExpr e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.inferExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferExpr" (showCons x1))

d_OP_inferExpr_dot_uscore_hash_lambda36 :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
d_OP_inferExpr_dot_uscore_hash_lambda36 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x3 cd cs)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_inferExpr_dot_uscore_hash_lambda36 l cd cs) (d_OP_inferExpr_dot_uscore_hash_lambda36 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_inferExpr_dot_uscore_hash_lambda36 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_inferExpr_dot_uscore_hash_lambda36 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.inferExpr._#lambda36" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.inferExpr._#lambda36" (showCons x1))

d_C_inferBranch :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferBranch x1 x2 x3 cd cs = case x3 of
     (Curry_AnnotatedFlatCurry.C_ABranch x4 x5) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x5 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs) (d_C_inferPattern (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x2 cd cs) x4 cd cs) cd cs) cd cs) (d_C_inferExpr x5 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (d_C_inferBranch x1 x2 l cd cs) (d_C_inferBranch x1 x2 r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> d_C_inferBranch x1 x2 z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((d_C_inferBranch x1 x2 e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.inferBranch" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.inferBranch" (showCons x3))

nd_C_inferBranch :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferBranch x1 x2 x3 s cd cs = case x3 of
     (Curry_AnnotatedFlatCurry.C_ABranch x4 x5) -> let
          s17 = s
           in (seq s17 (let
               s16 = leftSupply s17
               s18 = rightSupply s17
               s13 = leftSupply s18
               s15 = rightSupply s18
                in (seq s16 (seq s18 (seq s13 (seq s15 (Curry_Prelude.nd_C_apply (let
                    s12 = leftSupply s13
                    s14 = rightSupply s13
                    s0 = leftSupply s14
                    s10 = rightSupply s14
                     in (seq s12 (seq s14 (seq s0 (seq s10 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                         s9 = leftSupply s10
                         s11 = rightSupply s10
                         s4 = leftSupply s11
                         s8 = rightSupply s11
                          in (seq s9 (seq s11 (seq s4 (seq s8 (Curry_Prelude.nd_C_apply (let
                              s3 = leftSupply s4
                              s5 = rightSupply s4
                              s1 = leftSupply s5
                              s2 = rightSupply s5
                               in (seq s3 (seq s5 (seq s1 (seq s2 (Curry_Prelude.nd_C_apply (let
                                    in (nd_OP_plus_plus_eq s1 cd cs)) (let
                                    in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                                         in (Curry_Prelude.OP_Cons (let
                                              in (d_OP_eq_dot_eq x1 (let
                                                   in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x5 s2 cd cs)) cd cs)) Curry_Prelude.OP_List))))) s3 cd cs)))))) (let
                              s7 = leftSupply s8
                              s6 = rightSupply s8
                               in (seq s7 (seq s6 (nd_C_inferPattern (let
                                    in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x2 s6 cd cs)) x4 s7 cd cs)))) s9 cd cs)))))) s12 cd cs)))))) (let
                     in (nd_C_inferExpr x5 s15 cd cs)) s16 cd cs)))))))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (nd_C_inferBranch x1 x2 l s cd cs) (nd_C_inferBranch x1 x2 r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> nd_C_inferBranch x1 x2 z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((nd_C_inferBranch x1 x2 e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.inferBranch" [(show x1),(show x2),(show x3)] info)
     _ -> failCons cd (consFail "Inference.inferBranch" (showCons x3))

d_C_inferPattern :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferPattern x1 x2 cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5) -> d_C__case_10 x5 x3 x1 x4 cd cs
     (Curry_AnnotatedFlatCurry.C_ALPattern x8 x9) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8 cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x8 (d_C_literalType x9 cd cs) cd cs) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r) -> narrow d i (d_C_inferPattern x1 l cd cs) (d_C_inferPattern x1 r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs) -> narrows cs d i (\z -> d_C_inferPattern x1 z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_APattern d c e) -> guardCons d c ((d_C_inferPattern x1 e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern d info) -> failCons d (traceFail "Inference.inferPattern" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferPattern" (showCons x2))

nd_C_inferPattern :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferPattern x1 x2 s cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C__case_10 x5 x3 x1 x4 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.C_ALPattern x8 x9) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8 cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x8 (d_C_literalType x9 cd cs) cd cs) Curry_Prelude.OP_List)))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r) -> narrow d i (nd_C_inferPattern x1 l s cd cs) (nd_C_inferPattern x1 r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs) -> narrows cs d i (\z -> nd_C_inferPattern x1 z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_APattern d c e) -> guardCons d c ((nd_C_inferPattern x1 e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern d info) -> failCons d (traceFail "Inference.inferPattern" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferPattern" (showCons x2))

d_C_inferVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferVars x1 x2 cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6) -> Curry_ErrorState.d_C_concatMapES (d_C_inferVars x1) x6 cd cs
     (Curry_AnnotatedFlatCurry.C_ACase x7 x8 x9 x10) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_concatMapES (d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1) x10 cd cs) cd cs) (d_C_inferVars x1 x9 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AVar x11 x12) -> d_C__case_9 x1 x12 x11 (Curry_Prelude.d_C_lookup x12 x1 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALit x14 x15) -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (d_C_inferVars x1 x17 cd cs) cd cs) (d_C_inferVars x1 x18 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_concatMapES (d_C_inferVars x1) (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 cd cs) cd cs) cd cs) (d_C_inferVars x1 x21 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AFree x22 x23 x24) -> d_C_inferVars x1 x24 cd cs
     (Curry_AnnotatedFlatCurry.C_ATyped x25 x26 x27) -> d_C_inferVars x1 x26 cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (d_C_inferVars x1 l cd cs) (d_C_inferVars x1 r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> d_C_inferVars x1 z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((d_C_inferVars x1 e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.inferVars" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferVars" (showCons x2))

nd_C_inferVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferVars x1 x2 s cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x1)) x6 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.C_ACase x7 x8 x9 x10) -> let
          s7 = s
           in (seq s7 (let
               s6 = leftSupply s7
               s8 = rightSupply s7
               s3 = leftSupply s8
               s5 = rightSupply s8
                in (seq s6 (seq s8 (seq s3 (seq s5 (Curry_Prelude.nd_C_apply (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1)) x10 s1 cd cs)) s2 cd cs)))))) (let
                     in (nd_C_inferVars x1 x9 s5 cd cs)) s6 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_AVar x11 x12) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C__case_9 x1 x12 x11 (Curry_Prelude.d_C_lookup x12 x1 cd cs) s0 cd cs)))
     (Curry_AnnotatedFlatCurry.C_ALit x14 x15) -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> let
          s7 = s
           in (seq s7 (let
               s6 = leftSupply s7
               s8 = rightSupply s7
               s3 = leftSupply s8
               s5 = rightSupply s8
                in (seq s6 (seq s8 (seq s3 (seq s5 (Curry_Prelude.nd_C_apply (let
                    s2 = leftSupply s3
                    s4 = rightSupply s3
                    s0 = leftSupply s4
                    s1 = rightSupply s4
                     in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (nd_C_inferVars x1 x17 s1 cd cs)) s2 cd cs)))))) (let
                     in (nd_C_inferVars x1 x18 s5 cd cs)) s6 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          s9 = s
           in (seq s9 (let
               s8 = leftSupply s9
               s10 = rightSupply s9
               s5 = leftSupply s10
               s7 = rightSupply s10
                in (seq s8 (seq s10 (seq s5 (seq s7 (Curry_Prelude.nd_C_apply (let
                    s4 = leftSupply s5
                    s6 = rightSupply s5
                    s0 = leftSupply s6
                    s3 = rightSupply s6
                     in (seq s4 (seq s6 (seq s0 (seq s3 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                         s2 = leftSupply s3
                         s1 = rightSupply s3
                          in (seq s2 (seq s1 (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x1)) (let
                               in (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 s1 cd cs)) s2 cd cs)))) s4 cd cs)))))) (let
                     in (nd_C_inferVars x1 x21 s7 cd cs)) s8 cd cs)))))))
     (Curry_AnnotatedFlatCurry.C_AFree x22 x23 x24) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C_inferVars x1 x24 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.C_ATyped x25 x26 x27) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C_inferVars x1 x26 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (nd_C_inferVars x1 l s cd cs) (nd_C_inferVars x1 r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> nd_C_inferVars x1 z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((nd_C_inferVars x1 e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.inferVars" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferVars" (showCons x2))

d_OP_inferVars_dot_genBranchVarPairs_dot_265 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 x2 cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_ABranch x3 x4) -> d_C_inferVars x1 x4 cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 l cd cs) (d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((d_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.inferVars.genBranchVarPairs.265" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferVars.genBranchVarPairs.265" (showCons x2))

nd_OP_inferVars_dot_genBranchVarPairs_dot_265 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 x2 s cd cs = case x2 of
     (Curry_AnnotatedFlatCurry.C_ABranch x3 x4) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C_inferVars x1 x4 s0 cd cs)))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 l s cd cs) (nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((nd_OP_inferVars_dot_genBranchVarPairs_dot_265 x1 e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.inferVars.genBranchVarPairs.265" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.inferVars.genBranchVarPairs.265" (showCons x2))

d_C_literalType :: Curry_FlatCurry.C_Literal -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_literalType x1 cd cs = case x1 of
     (Curry_FlatCurry.C_Intc x2) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) Curry_Prelude.OP_List)))) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Floatc x3) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) Curry_Prelude.OP_List)))))) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Charc x4) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) Curry_Prelude.OP_List))))) Curry_Prelude.OP_List
     (Curry_FlatCurry.Choice_C_Literal d i l r) -> narrow d i (d_C_literalType l cd cs) (d_C_literalType r cd cs)
     (Curry_FlatCurry.Choices_C_Literal d i xs) -> narrows cs d i (\z -> d_C_literalType z cd cs) xs
     (Curry_FlatCurry.Guard_C_Literal d c e) -> guardCons d c ((d_C_literalType e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_Literal d info) -> failCons d (traceFail "Inference.literalType" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.literalType" (showCons x1))

d_C_exprType :: Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_exprType cd cs = Curry_AnnotatedFlatCurryGoodies.d_C_annExpr

d_C_unification :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_unification x1 cd cs = d_C__case_7 x1 (Curry_Unification.d_C_unify (Curry_Prelude.d_C_apply (d_C_fromTypeEqs cd cs) x1 cd cs) cd cs) cd cs

nd_C_unification :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_unification x1 s cd cs = let
     s4 = s
      in (seq s4 (let
          s3 = leftSupply s4
          s2 = rightSupply s4
           in (seq s3 (seq s2 (nd_C__case_7 x1 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_Unification.nd_C_unify (let
                     in (Curry_Prelude.nd_C_apply (wrapDX id (d_C_fromTypeEqs cd cs)) x1 s0 cd cs)) s1 cd cs)))) s3 cd cs)))))

d_OP_unification_dot_uscore_hash_lambda39 :: Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_UnificationSpec.C_Term -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_OP_unification_dot_uscore_hash_lambda39 x1 cd cs = d_C_toTypeExpr

d_C_fromTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term)
d_C_fromTypeEqs cd cs = Curry_Prelude.d_C_map d_OP_fromTypeEqs_dot_uscore_hash_lambda40

d_OP_fromTypeEqs_dot_uscore_hash_lambda40 :: Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term
d_OP_fromTypeEqs_dot_uscore_hash_lambda40 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.OP_Tuple2 (d_C_fromTypeExpr x2 cd cs) (d_C_fromTypeExpr x3 cd cs)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_fromTypeEqs_dot_uscore_hash_lambda40 l cd cs) (d_OP_fromTypeEqs_dot_uscore_hash_lambda40 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_fromTypeEqs_dot_uscore_hash_lambda40 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_fromTypeEqs_dot_uscore_hash_lambda40 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.fromTypeEqs._#lambda40" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.fromTypeEqs._#lambda40" (showCons x1))

d_C_toTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term) -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C_toTypeEqs cd cs = Curry_Prelude.d_C_map d_OP_toTypeEqs_dot_uscore_hash_lambda41

d_OP_toTypeEqs_dot_uscore_hash_lambda41 :: Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr
d_OP_toTypeEqs_dot_uscore_hash_lambda41 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> d_OP_eq_dot_eq (d_C_toTypeExpr x2 cd cs) (d_C_toTypeExpr x3 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_toTypeEqs_dot_uscore_hash_lambda41 l cd cs) (d_OP_toTypeEqs_dot_uscore_hash_lambda41 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_toTypeEqs_dot_uscore_hash_lambda41 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_toTypeEqs_dot_uscore_hash_lambda41 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.toTypeEqs._#lambda41" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.toTypeEqs._#lambda41" (showCons x1))

d_C_fromTypeExpr :: Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_UnificationSpec.C_Term
d_C_fromTypeExpr x1 cd cs = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_UnificationSpec.C_TermVar x2
     (Curry_FlatCurry.C_TCons x3 x4) -> Curry_UnificationSpec.C_TermCons (d_C_fromQName x3 cd cs) (Curry_Prelude.d_C_map d_C_fromTypeExpr x4 cd cs)
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_UnificationSpec.C_TermCons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons (d_C_fromTypeExpr x5 cd cs) (Curry_Prelude.OP_Cons (d_C_fromTypeExpr x6 cd cs) Curry_Prelude.OP_List))
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (d_C_fromTypeExpr l cd cs) (d_C_fromTypeExpr r cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C_fromTypeExpr z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C_fromTypeExpr e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.fromTypeExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.fromTypeExpr" (showCons x1))

d_C_toTypeExpr :: Curry_UnificationSpec.C_Term -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_toTypeExpr x1 cd cs = case x1 of
     (Curry_UnificationSpec.C_TermVar x2) -> Curry_FlatCurry.C_TVar x2
     (Curry_UnificationSpec.C_TermCons x3 x4) -> d_C__case_6 x3 x4 (Curry_Prelude.d_OP_eq_eq x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) Curry_Prelude.OP_List)) cd cs) cd cs
     (Curry_UnificationSpec.Choice_C_Term d i l r) -> narrow d i (d_C_toTypeExpr l cd cs) (d_C_toTypeExpr r cd cs)
     (Curry_UnificationSpec.Choices_C_Term d i xs) -> narrows cs d i (\z -> d_C_toTypeExpr z cd cs) xs
     (Curry_UnificationSpec.Guard_C_Term d c e) -> guardCons d c ((d_C_toTypeExpr e cd) $! (addCs c cs))
     (Curry_UnificationSpec.Fail_C_Term d info) -> failCons d (traceFail "Inference.toTypeExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.toTypeExpr" (showCons x1))

d_C_fromQName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fromQName x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ';'#) Curry_Prelude.OP_List) x3 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C_fromQName l cd cs) (d_C_fromQName r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C_fromQName z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C_fromQName e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.fromQName" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.fromQName" (showCons x1))

d_C_toQName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_toQName x1 cd cs = let
     x2 = d_C_splitFirst x1 (Curry_Prelude.C_Char ';'#) cd cs
      in (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_fst x2 cd cs) (Curry_Prelude.d_C_snd x2 cd cs))

d_C_splitFirst :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_List t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C_splitFirst x1 x2 cd cs = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> let
          x5 = d_C_splitFirst x4 x2 cd cs
           in (d_C__case_4 x2 x3 x5 x4 (Curry_Prelude.d_OP_eq_eq x3 x2 cd cs) cd cs)
     (Curry_Prelude.Choice_OP_List d i l r) -> narrow d i (d_C_splitFirst l x2 cd cs) (d_C_splitFirst r x2 cd cs)
     (Curry_Prelude.Choices_OP_List d i xs) -> narrows cs d i (\z -> d_C_splitFirst z x2 cd cs) xs
     (Curry_Prelude.Guard_OP_List d c e) -> guardCons d c ((d_C_splitFirst e x2 cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_List d info) -> failCons d (traceFail "Inference.splitFirst" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.splitFirst" (showCons x1))

d_C_showUnificationError :: Curry_UnificationSpec.C_UnificationError -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showUnificationError x1 cd cs = case x1 of
     (Curry_UnificationSpec.C_Clash x2 x3) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr (d_C_toTypeExpr x2 cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))) (d_C_showTypeExpr (d_C_toTypeExpr x3 cd cs) cd cs) cd cs) cd cs) cd cs
     (Curry_UnificationSpec.C_OccurCheck x4 x5) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr (d_C_toTypeExpr (Curry_UnificationSpec.C_TermVar x4) cd cs) cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))) (d_C_showTypeExpr (d_C_toTypeExpr x5 cd cs) cd cs) cd cs) cd cs) cd cs
     (Curry_UnificationSpec.Choice_C_UnificationError d i l r) -> narrow d i (d_C_showUnificationError l cd cs) (d_C_showUnificationError r cd cs)
     (Curry_UnificationSpec.Choices_C_UnificationError d i xs) -> narrows cs d i (\z -> d_C_showUnificationError z cd cs) xs
     (Curry_UnificationSpec.Guard_C_UnificationError d c e) -> guardCons d c ((d_C_showUnificationError e cd) $! (addCs c cs))
     (Curry_UnificationSpec.Fail_C_UnificationError d info) -> failCons d (traceFail "Inference.showUnificationError" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.showUnificationError" (showCons x1))

d_C_showTypeExpr :: Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeExpr x1 cd cs = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs) cd cs
     (Curry_FlatCurry.C_TCons x3 x4) -> d_C__case_2 x4 x3 cd cs
     (Curry_FlatCurry.C_FuncType x7 x8) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr x7 cd cs) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr x8 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) cd cs) cd cs) cd cs) cd cs
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (d_C_showTypeExpr l cd cs) (d_C_showTypeExpr r cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C_showTypeExpr z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C_showTypeExpr e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.showTypeExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.showTypeExpr" (showCons x1))

d_C_normFunc :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_C_normFunc x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> let
          x7 = Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4)) (d_C_normType x5 cd cs) (d_C_normRule x6 cd cs) cd cs
           in (d_C__case_1 x7 x2 (Curry_ErrorState.d_C_evalES x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)) cd cs) cd cs)
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl d i l r) -> narrow d i (d_C_normFunc l cd cs) (d_C_normFunc r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl d i xs) -> narrows cs d i (\z -> d_C_normFunc z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl d c e) -> guardCons d c ((d_C_normFunc e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl d info) -> failCons d (traceFail "Inference.normFunc" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normFunc" (showCons x1))

d_C_normType :: Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normType x1 cd cs = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_normType_dot_uscore_hash_lambda43 x2)
     (Curry_FlatCurry.C_TCons x3 x4) -> Curry_ErrorState.d_C_liftES (acceptCs id (Curry_FlatCurry.C_TCons x3)) (Curry_ErrorState.d_C_mapES d_C_normType x4 cd cs) cd cs
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType) (d_C_normType x5 cd cs) (d_C_normType x6 cd cs) cd cs
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (d_C_normType l cd cs) (d_C_normType r cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C_normType z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C_normType e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.normType" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normType" (showCons x1))

nd_C_normType :: Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normType x1 s cd cs = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_normType_dot_uscore_hash_lambda43 x2)))
     (Curry_FlatCurry.C_TCons x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (acceptCs id (Curry_FlatCurry.C_TCons x3))) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normType) x4 s0 cd cs)) s1 cd cs)))))
     (Curry_FlatCurry.C_FuncType x5 x6) -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType)) (let
                     in (nd_C_normType x5 s0 cd cs)) (let
                     in (nd_C_normType x6 s1 cd cs)) s2 cd cs)))))))
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (nd_C_normType l s cd cs) (nd_C_normType r s cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> nd_C_normType z s cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((nd_C_normType e s cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference.normType" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normType" (showCons x1))

d_OP_normType_dot_uscore_hash_lambda43 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP_normType_dot_uscore_hash_lambda43 x1 x2 cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> d_C__case_0 x1 x4 x3 (Curry_FiniteMap.d_C_lookupFM x4 x1 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_normType_dot_uscore_hash_lambda43 x1 l cd cs) (d_OP_normType_dot_uscore_hash_lambda43 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_normType_dot_uscore_hash_lambda43 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_normType_dot_uscore_hash_lambda43 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normType._#lambda43" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.normType._#lambda43" (showCons x2))

nd_OP_normType_dot_uscore_hash_lambda43 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normType_dot_uscore_hash_lambda43 x1 x2 s cd cs = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (nd_C__case_0 x1 x4 x3 (let
                     in (Curry_FiniteMap.nd_C_lookupFM x4 x1 s0 cd cs)) s1 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_OP_normType_dot_uscore_hash_lambda43 x1 l s cd cs) (nd_OP_normType_dot_uscore_hash_lambda43 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_OP_normType_dot_uscore_hash_lambda43 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_OP_normType_dot_uscore_hash_lambda43 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normType._#lambda43" [(show x1),(show x2)] info)
     _ -> failCons cd (consFail "Inference.normType._#lambda43" (showCons x2))

d_C_normRule :: Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normRule x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_ARule x2 x3 x4) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule) (d_C_normType x2 cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x3 cd cs) (d_C_normExpr x4 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AExternal x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_normRule_dot_uscore_hash_lambda45 x6) (d_C_normType x5 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r) -> narrow d i (d_C_normRule l cd cs) (d_C_normRule r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs) -> narrows cs d i (\z -> d_C_normRule z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ARule d c e) -> guardCons d c ((d_C_normRule e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule d info) -> failCons d (traceFail "Inference.normRule" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normRule" (showCons x1))

nd_C_normRule :: Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normRule x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_ARule x2 x3 x4) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule)) (let
                     in (nd_C_normType x2 s0 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x3 s1 cd cs)) (let
                     in (nd_C_normExpr x4 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_AExternal x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normRule_dot_uscore_hash_lambda45 x6)) (let
                     in (nd_C_normType x5 s0 cd cs)) s1 cd cs)))))
     (Curry_AnnotatedFlatCurry.Choice_C_ARule d i l r) -> narrow d i (nd_C_normRule l s cd cs) (nd_C_normRule r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule d i xs) -> narrows cs d i (\z -> nd_C_normRule z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ARule d c e) -> guardCons d c ((nd_C_normRule e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule d info) -> failCons d (traceFail "Inference.normRule" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normRule" (showCons x1))

d_OP_normRule_dot_uscore_hash_lambda45 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
d_OP_normRule_dot_uscore_hash_lambda45 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_AExternal x2 x1

d_C_normExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normExpr x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> Curry_ErrorState.d_C_liftES (d_OP_normExpr_dot_uscore_hash_lambda46 x3) (d_C_normType x2 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> Curry_ErrorState.d_C_liftES (d_OP_normExpr_dot_uscore_hash_lambda47 x5) (d_C_normType x4 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> Curry_ErrorState.d_C_liftES3 (d_OP_normExpr_dot_uscore_hash_lambda48 x7) (d_C_normType x6 cd cs) (d_C_normSnd x8 cd cs) (Curry_ErrorState.d_C_mapES d_C_normExpr x9 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALet x10 x11 x12) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet) (d_C_normType x10 cd cs) (Curry_ErrorState.d_C_mapES d_OP_normExpr_dot_normBinding_dot_388 x11 cd cs) (d_C_normExpr x12 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AOr x13 x14 x15) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr) (d_C_normType x13 cd cs) (d_C_normExpr x14 cd cs) (d_C_normExpr x15 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ACase x16 x17 x18 x19) -> Curry_ErrorState.d_C_liftES3 (d_OP_normExpr_dot_uscore_hash_lambda50 x17) (d_C_normType x16 cd cs) (d_C_normExpr x18 cd cs) (Curry_ErrorState.d_C_mapES d_C_normBranch x19 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_AFree x20 x21 x22) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree) (d_C_normType x20 cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x21 cd cs) (d_C_normExpr x22 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ATyped x23 x24 x25) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped) (d_C_normType x23 cd cs) (d_C_normExpr x24 cd cs) (d_C_normType x25 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (d_C_normExpr l cd cs) (d_C_normExpr r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> d_C_normExpr z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((d_C_normExpr e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.normExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normExpr" (showCons x1))

nd_C_normExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normExpr x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normExpr_dot_uscore_hash_lambda46 x3)) (let
                     in (nd_C_normType x2 s0 cd cs)) s1 cd cs)))))
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normExpr_dot_uscore_hash_lambda47 x5)) (let
                     in (nd_C_normType x4 s0 cd cs)) s1 cd cs)))))
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (d_OP_normExpr_dot_uscore_hash_lambda48 x7)) (let
                     in (nd_C_normType x6 s0 cd cs)) (let
                     in (nd_C_normSnd x8 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normExpr) x9 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_ALet x10 x11 x12) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet)) (let
                     in (nd_C_normType x10 s0 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_normExpr_dot_normBinding_dot_388) x11 s1 cd cs)) (let
                     in (nd_C_normExpr x12 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_AOr x13 x14 x15) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr)) (let
                     in (nd_C_normType x13 s0 cd cs)) (let
                     in (nd_C_normExpr x14 s1 cd cs)) (let
                     in (nd_C_normExpr x15 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_ACase x16 x17 x18 x19) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (d_OP_normExpr_dot_uscore_hash_lambda50 x17)) (let
                     in (nd_C_normType x16 s0 cd cs)) (let
                     in (nd_C_normExpr x18 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normBranch) x19 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_AFree x20 x21 x22) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree)) (let
                     in (nd_C_normType x20 s0 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x21 s1 cd cs)) (let
                     in (nd_C_normExpr x22 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_ATyped x23 x24 x25) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped)) (let
                     in (nd_C_normType x23 s0 cd cs)) (let
                     in (nd_C_normExpr x24 s1 cd cs)) (let
                     in (nd_C_normType x25 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr d i l r) -> narrow d i (nd_C_normExpr l s cd cs) (nd_C_normExpr r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr d i xs) -> narrows cs d i (\z -> nd_C_normExpr z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr d c e) -> guardCons d c ((nd_C_normExpr e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr d info) -> failCons d (traceFail "Inference.normExpr" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normExpr" (showCons x1))

d_OP_normExpr_dot_uscore_hash_lambda46 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot_uscore_hash_lambda46 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_AVar x2 x1

d_OP_normExpr_dot_uscore_hash_lambda47 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot_uscore_hash_lambda47 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_ALit x2 x1

d_OP_normExpr_dot_uscore_hash_lambda48 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot_uscore_hash_lambda48 x1 x2 cd cs = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1)

d_OP_normExpr_dot_normBinding_dot_388 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP_normExpr_dot_normBinding_dot_388 x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_normExpr x3 cd cs) (d_OP_normExpr_dot_normBinding_dot_388_dot_uscore_hash_lambda49 x2)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_OP_normExpr_dot_normBinding_dot_388 l cd cs) (d_OP_normExpr_dot_normBinding_dot_388 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_OP_normExpr_dot_normBinding_dot_388 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_OP_normExpr_dot_normBinding_dot_388 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normExpr.normBinding.388" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normExpr.normBinding.388" (showCons x1))

nd_OP_normExpr_dot_normBinding_dot_388 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normExpr_dot_normBinding_dot_388 x1 s cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_normExpr x3 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_normExpr_dot_normBinding_dot_388_dot_uscore_hash_lambda49 x2))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_OP_normExpr_dot_normBinding_dot_388 l s cd cs) (nd_OP_normExpr_dot_normBinding_dot_388 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_OP_normExpr_dot_normBinding_dot_388 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_OP_normExpr_dot_normBinding_dot_388 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normExpr.normBinding.388" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normExpr.normBinding.388" (showCons x1))

d_OP_normExpr_dot_normBinding_dot_388_dot_uscore_hash_lambda49 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) t1)
d_OP_normExpr_dot_normBinding_dot_388_dot_uscore_hash_lambda49 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

d_OP_normExpr_dot_uscore_hash_lambda50 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot_uscore_hash_lambda50 x1 x2 cd cs = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1)

d_C_normSnd :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normSnd x1 cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_normType x3 cd cs) (d_OP_normSnd_dot_uscore_hash_lambda51 x2)
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C_normSnd l cd cs) (d_C_normSnd r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C_normSnd z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C_normSnd e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normSnd" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normSnd" (showCons x1))

nd_C_normSnd :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normSnd x1 s cd cs = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_normType x3 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_normSnd_dot_uscore_hash_lambda51 x2))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C_normSnd l s cd cs) (nd_C_normSnd r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C_normSnd z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C_normSnd e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference.normSnd" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normSnd" (showCons x1))

d_OP_normSnd_dot_uscore_hash_lambda51 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) t1)
d_OP_normSnd_dot_uscore_hash_lambda51 x1 x2 cd cs = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

d_C_normBranch :: Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normBranch x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_ABranch x2 x3) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch) (d_C_normPattern x2 cd cs) (d_C_normExpr x3 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (d_C_normBranch l cd cs) (d_C_normBranch r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> d_C_normBranch z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((d_C_normBranch e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.normBranch" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normBranch" (showCons x1))

nd_C_normBranch :: Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normBranch x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_ABranch x2 x3) -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch)) (let
                     in (nd_C_normPattern x2 s0 cd cs)) (let
                     in (nd_C_normExpr x3 s1 cd cs)) s2 cd cs)))))))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr d i l r) -> narrow d i (nd_C_normBranch l s cd cs) (nd_C_normBranch r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr d i xs) -> narrows cs d i (\z -> nd_C_normBranch z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr d c e) -> guardCons d c ((nd_C_normBranch e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr d info) -> failCons d (traceFail "Inference.normBranch" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normBranch" (showCons x1))

d_C_normPattern :: Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normPattern x1 cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_APattern x2 x3 x4) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern) (d_C_normType x2 cd cs) (d_C_normSnd x3 cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x4 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.C_ALPattern x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_normPattern_dot_uscore_hash_lambda52 x6) (d_C_normType x5 cd cs) cd cs
     (Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r) -> narrow d i (d_C_normPattern l cd cs) (d_C_normPattern r cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs) -> narrows cs d i (\z -> d_C_normPattern z cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_APattern d c e) -> guardCons d c ((d_C_normPattern e cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern d info) -> failCons d (traceFail "Inference.normPattern" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normPattern" (showCons x1))

nd_C_normPattern :: Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normPattern x1 s cd cs = case x1 of
     (Curry_AnnotatedFlatCurry.C_APattern x2 x3 x4) -> let
          s4 = s
           in (seq s4 (let
               s5 = leftSupply s4
               s6 = rightSupply s4
               s3 = leftSupply s5
               s0 = rightSupply s5
               s1 = leftSupply s6
               s2 = rightSupply s6
                in (seq s5 (seq s6 (seq s3 (seq s0 (seq s1 (seq s2 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern)) (let
                     in (nd_C_normType x2 s0 cd cs)) (let
                     in (nd_C_normSnd x3 s1 cd cs)) (let
                     in (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x4 s2 cd cs)) s3 cd cs)))))))))
     (Curry_AnnotatedFlatCurry.C_ALPattern x5 x6) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normPattern_dot_uscore_hash_lambda52 x6)) (let
                     in (nd_C_normType x5 s0 cd cs)) s1 cd cs)))))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern d i l r) -> narrow d i (nd_C_normPattern l s cd cs) (nd_C_normPattern r s cd cs)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern d i xs) -> narrows cs d i (\z -> nd_C_normPattern z s cd cs) xs
     (Curry_AnnotatedFlatCurry.Guard_C_APattern d c e) -> guardCons d c ((nd_C_normPattern e s cd) $! (addCs c cs))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern d info) -> failCons d (traceFail "Inference.normPattern" [(show x1)] info)
     _ -> failCons cd (consFail "Inference.normPattern" (showCons x1))

d_OP_normPattern_dot_uscore_hash_lambda52 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
d_OP_normPattern_dot_uscore_hash_lambda52 x1 x2 cd cs = Curry_AnnotatedFlatCurry.C_ALPattern x2 x1

d_C__case_0 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C__case_0 x1 x4 x3 x6 cd cs = case x6 of
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) (Curry_FiniteMap.d_C_addToFM x4 x1 x3 cd cs))) (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3)) cd cs
     (Curry_Prelude.C_Just x5) -> Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x5)
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_0 x1 x4 x3 l cd cs) (d_C__case_0 x1 x4 x3 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_0 x1 x4 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_0 x1 x4 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_0" [(show x1),(show x4),(show x3),(show x6)] info)
     _ -> failCons cd (consFail "Inference._case_0" (showCons x6))

nd_C__case_0 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C__case_0 x1 x4 x3 x6 s cd cs = case x6 of
     Curry_Prelude.C_Nothing -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_ErrorState.nd_OP_gt_plus (let
                     in (wrapDX id (Curry_ErrorState.d_C_puts (let
                          in (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) (let
                               in (Curry_FiniteMap.nd_C_addToFM x4 x1 x3 s0 cd cs))))))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3))) s1 cd cs)))))
     (Curry_Prelude.C_Just x5) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x5))
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_0 x1 x4 x3 l s cd cs) (nd_C__case_0 x1 x4 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_0 x1 x4 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_0 x1 x4 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_0" [(show x1),(show x4),(show x3),(show x6)] info)
     _ -> failCons cd (consFail "Inference._case_0" (showCons x6))

d_C__case_1 :: Curry_Prelude.Curry t0 => (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_C__case_1 x7 x2 x10 cd cs = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) Curry_Prelude.OP_List))))))) cd cs) cd cs) cd cs
     (Curry_Prelude.C_Right x9) -> Curry_ErrorState.d_C_returnES x9
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (d_C__case_1 x7 x2 l cd cs) (d_C__case_1 x7 x2 r cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> d_C__case_1 x7 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((d_C__case_1 x7 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_1" [(show x7),(show x2),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_1" (showCons x10))

nd_C__case_1 :: Curry_Prelude.Curry t0 => Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0))
nd_C__case_1 x7 x2 x10 s cd cs = case x10 of
     (Curry_Prelude.C_Left x8) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) Curry_Prelude.OP_List))))))) cd cs) cd cs) s0 cd cs)))
     (Curry_Prelude.C_Right x9) -> wrapDX id (Curry_ErrorState.d_C_returnES x9)
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (nd_C__case_1 x7 x2 l s cd cs) (nd_C__case_1 x7 x2 r s cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> nd_C__case_1 x7 x2 z s cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((nd_C__case_1 x7 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_1" [(show x7),(show x2),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_1" (showCons x10))

d_C__case_2 :: Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_2 x4 x3 cd cs = case x3 of
     (Curry_Prelude.OP_Tuple2 x5 x6) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) Curry_Prelude.OP_List)))))))) (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus x6 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) Curry_Prelude.OP_List))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_concat (Curry_Prelude.d_C_map d_C_showTypeExpr x4 cd cs) cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) cd cs) cd cs) cd cs) cd cs) cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_2 x4 l cd cs) (d_C__case_2 x4 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_2 x4 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_2 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference._case_2" [(show x4),(show x3)] info)
     _ -> failCons cd (consFail "Inference._case_2" (showCons x3))

d_C__case_4 :: Curry_Prelude.Curry t0 => t0 -> t0 -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C__case_4 x2 x3 x5 x4 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x4
     Curry_Prelude.C_False -> d_C__case_3 x5 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_4 x2 x3 x5 x4 l cd cs) (d_C__case_4 x2 x3 x5 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_4 x2 x3 x5 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_4 x2 x3 x5 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Inference._case_4" [(show x2),(show x3),(show x5),(show x4),(show x6)] info)
     _ -> failCons cd (consFail "Inference._case_4" (showCons x6))

d_C__case_3 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C__case_3 x5 x3 x6 cd cs = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3 (Curry_Prelude.d_C_fst x5 cd cs)) (Curry_Prelude.d_C_snd x5 cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_3 x5 x3 l cd cs) (d_C__case_3 x5 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_3 x5 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_3 x5 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Inference._case_3" [(show x5),(show x3),(show x6)] info)
     _ -> failCons cd (consFail "Inference._case_3" (showCons x6))

d_C__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_UnificationSpec.C_Term -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C__case_6 x3 x4 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_FlatCurry.C_FuncType (d_C_toTypeExpr (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 0#) cd cs) cd cs) (d_C_toTypeExpr (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 1#) cd cs) cd cs)
     Curry_Prelude.C_False -> d_C__case_5 x4 x3 (Curry_Prelude.d_C_otherwise cd cs) cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_6 x3 x4 l cd cs) (d_C__case_6 x3 x4 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_6 x3 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_6 x3 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Inference._case_6" [(show x3),(show x4),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_6" (showCons x5))

d_C__case_5 :: Curry_Prelude.OP_List Curry_UnificationSpec.C_Term -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C__case_5 x4 x3 x5 cd cs = case x5 of
     Curry_Prelude.C_True -> Curry_FlatCurry.C_TCons (d_C_toQName x3 cd cs) (Curry_Prelude.d_C_map d_C_toTypeExpr x4 cd cs)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_5 x4 x3 l cd cs) (d_C__case_5 x4 x3 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_5 x4 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_5 x4 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Inference._case_5" [(show x4),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_5" (showCons x5))

d_C__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Either Curry_UnificationSpec.C_UnificationError (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_UnificationSpec.C_Term) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_7 x1 x4 cd cs = case x4 of
     (Curry_Prelude.C_Left x2) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (d_C_showUnificationError x2 cd cs) cd cs
     (Curry_Prelude.C_Right x3) -> Curry_ErrorState.d_C_returnES (Curry_FiniteMap.d_C_mapFM d_OP_unification_dot_uscore_hash_lambda39 x3 cd cs)
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (d_C__case_7 x1 l cd cs) (d_C__case_7 x1 r cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> d_C__case_7 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((d_C__case_7 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_7" [(show x1),(show x4)] info)
     _ -> failCons cd (consFail "Inference._case_7" (showCons x4))

nd_C__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Either Curry_UnificationSpec.C_UnificationError (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_UnificationSpec.C_Term) -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_7 x1 x4 s cd cs = case x4 of
     (Curry_Prelude.C_Left x2) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (d_C_showUnificationError x2 cd cs) s0 cd cs)))
     (Curry_Prelude.C_Right x3) -> let
          s0 = s
           in (seq s0 (let
                in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                     in (Curry_FiniteMap.nd_C_mapFM (wrapDX (wrapDX id) d_OP_unification_dot_uscore_hash_lambda39) x3 s0 cd cs))))))
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (nd_C__case_7 x1 l s cd cs) (nd_C__case_7 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> nd_C__case_7 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((nd_C__case_7 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_7" [(show x1),(show x4)] info)
     _ -> failCons cd (consFail "Inference._case_7" (showCons x4))

d_C__case_9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_9 x1 x12 x11 x14 cd cs = case x14 of
     (Curry_Prelude.C_Just x13) -> Curry_ErrorState.d_C_returnES (d_C__case_8 x13 x11 (Curry_Prelude.d_OP_eq_eq x11 x13 cd cs) cd cs)
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_9 x1 x12 x11 l cd cs) (d_C__case_9 x1 x12 x11 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_9 x1 x12 x11 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_9 x1 x12 x11 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_9" [(show x1),(show x12),(show x11),(show x14)] info)
     _ -> failCons cd (consFail "Inference._case_9" (showCons x14))

nd_C__case_9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_9 x1 x12 x11 x14 s cd cs = case x14 of
     (Curry_Prelude.C_Just x13) -> wrapDX id (Curry_ErrorState.d_C_returnES (d_C__case_8 x13 x11 (Curry_Prelude.d_OP_eq_eq x11 x13 cd cs) cd cs))
     Curry_Prelude.C_Nothing -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_9 x1 x12 x11 l s cd cs) (nd_C__case_9 x1 x12 x11 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_9 x1 x12 x11 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_9 x1 x12 x11 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_9" [(show x1),(show x12),(show x11),(show x14)] info)
     _ -> failCons cd (consFail "Inference._case_9" (showCons x14))

d_C__case_8 :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C__case_8 x13 x11 x14 cd cs = case x14 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x11 x13 cd cs) Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool d i l r) -> narrow d i (d_C__case_8 x13 x11 l cd cs) (d_C__case_8 x13 x11 r cd cs)
     (Curry_Prelude.Choices_C_Bool d i xs) -> narrows cs d i (\z -> d_C__case_8 x13 x11 z cd cs) xs
     (Curry_Prelude.Guard_C_Bool d c e) -> guardCons d c ((d_C__case_8 x13 x11 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Bool d info) -> failCons d (traceFail "Inference._case_8" [(show x13),(show x11),(show x14)] info)
     _ -> failCons cd (consFail "Inference._case_8" (showCons x14))

d_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_10 x5 x3 x1 x4 cd cs = case x4 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_returnES) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 cd cs) (d_C_matchApp x3 x7 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x5 cd cs) cd cs)) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_10 x5 x3 x1 l cd cs) (d_C__case_10 x5 x3 x1 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_10 x5 x3 x1 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_10 x5 x3 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference._case_10" [(show x5),(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "Inference._case_10" (showCons x4))

nd_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_10 x5 x3 x1 x4 s cd cs = case x4 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> let
          s2 = s
           in (seq s2 (let
               s1 = leftSupply s2
               s0 = rightSupply s2
                in (seq s1 (seq s0 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_returnES)) (let
                     in (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 cd cs) (let
                          in (d_C_matchApp x3 x7 (let
                               in (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x5 s0 cd cs)) cd cs)))) s1 cd cs)))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C__case_10 x5 x3 x1 l s cd cs) (nd_C__case_10 x5 x3 x1 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C__case_10 x5 x3 x1 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C__case_10 x5 x3 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference._case_10" [(show x5),(show x3),(show x1),(show x4)] info)
     _ -> failCons cd (consFail "Inference._case_10" (showCons x4))

d_C__case_11 :: Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_11 x9 x6 x8 cd cs = case x8 of
     (Curry_Prelude.OP_Tuple2 x10 x11) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq cd cs) (Curry_ErrorState.d_C_returnES (Curry_Prelude.d_OP_dollar (d_C_matchApp x6 x11) (Curry_Prelude.d_C_map (d_C_exprType cd cs) x9 cd cs) cd cs)) cd cs) (Curry_ErrorState.d_C_concatMapES d_C_inferExpr x9 cd cs) cd cs
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (d_C__case_11 x9 x6 l cd cs) (d_C__case_11 x9 x6 r cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> d_C__case_11 x9 x6 z cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((d_C__case_11 x9 x6 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference._case_11" [(show x9),(show x6),(show x8)] info)
     _ -> failCons cd (consFail "Inference._case_11" (showCons x8))

nd_C__case_11 :: Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_11 x9 x6 x8 s cd cs = case x8 of
     (Curry_Prelude.OP_Tuple2 x10 x11) -> let
          s9 = s
           in (seq s9 (let
               s8 = leftSupply s9
               s10 = rightSupply s9
               s5 = leftSupply s10
               s7 = rightSupply s10
                in (seq s8 (seq s10 (seq s5 (seq s7 (Curry_Prelude.nd_C_apply (let
                    s4 = leftSupply s5
                    s6 = rightSupply s5
                    s0 = leftSupply s6
                    s3 = rightSupply s6
                     in (seq s4 (seq s6 (seq s0 (seq s3 (Curry_Prelude.nd_C_apply (let
                          in (nd_OP_plus_plus_eq s0 cd cs)) (let
                          in (wrapDX id (Curry_ErrorState.d_C_returnES (let
                              s2 = leftSupply s3
                              s1 = rightSupply s3
                               in (seq s2 (seq s1 (Curry_Prelude.nd_OP_dollar (wrapDX id (d_C_matchApp x6 x11)) (let
                                    in (Curry_Prelude.nd_C_map (wrapDX id (d_C_exprType cd cs)) x9 s1 cd cs)) s2 cd cs))))))) s4 cd cs)))))) (let
                     in (Curry_ErrorState.nd_C_concatMapES (wrapNX id nd_C_inferExpr) x9 s7 cd cs)) s8 cd cs)))))))
     (Curry_Prelude.Choice_OP_Tuple2 d i l r) -> narrow d i (nd_C__case_11 x9 x6 l s cd cs) (nd_C__case_11 x9 x6 r s cd cs)
     (Curry_Prelude.Choices_OP_Tuple2 d i xs) -> narrows cs d i (\z -> nd_C__case_11 x9 x6 z s cd cs) xs
     (Curry_Prelude.Guard_OP_Tuple2 d c e) -> guardCons d c ((nd_C__case_11 x9 x6 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_OP_Tuple2 d info) -> failCons d (traceFail "Inference._case_11" [(show x9),(show x6),(show x8)] info)
     _ -> failCons cd (consFail "Inference._case_11" (showCons x8))

d_C__case_12 :: Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C__case_12 x5 x1 x4 x2 cd cs = case x2 of
     (Curry_FlatCurry.C_FuncType x6 x7) -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 x6 cd cs) (d_C_matchApp x1 x7 x5 cd cs)
     (Curry_FlatCurry.C_TVar x8) -> Curry_Prelude.d_C_error (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'A'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) Curry_Prelude.OP_List)))))))))))))))))) cd cs
     (Curry_FlatCurry.C_TCons x9 x10) -> Curry_Prelude.d_C_error (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'A'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) Curry_Prelude.OP_List)))))))))))))))))) cd cs
     (Curry_FlatCurry.Choice_C_TypeExpr d i l r) -> narrow d i (d_C__case_12 x5 x1 x4 l cd cs) (d_C__case_12 x5 x1 x4 r cd cs)
     (Curry_FlatCurry.Choices_C_TypeExpr d i xs) -> narrows cs d i (\z -> d_C__case_12 x5 x1 x4 z cd cs) xs
     (Curry_FlatCurry.Guard_C_TypeExpr d c e) -> guardCons d c ((d_C__case_12 x5 x1 x4 e cd) $! (addCs c cs))
     (Curry_FlatCurry.Fail_C_TypeExpr d info) -> failCons d (traceFail "Inference._case_12" [(show x5),(show x1),(show x4),(show x2)] info)
     _ -> failCons cd (consFail "Inference._case_12" (showCons x2))

d_C__case_13 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_13 x1 x3 x5 cd cs = case x5 of
     (Curry_Prelude.C_Just x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x4)
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd cs) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda17 x3 x1)
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_13 x1 x3 l cd cs) (d_C__case_13 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_13 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_13 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_13" [(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_13" (showCons x5))

nd_C__case_13 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_13 x1 x3 x5 s cd cs = case x5 of
     (Curry_Prelude.C_Just x4) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x4))
     Curry_Prelude.C_Nothing -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_nextTVar s0 cd cs)) (wrapDX (wrapDX id) (d_OP_freshVariant_dot_rename_dot_120_dot_uscore_hash_lambda17 x3 x1))))))
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_13 x1 x3 l s cd cs) (nd_C__case_13 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_13 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_13 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_13" [(show x1),(show x3),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_13" (showCons x5))

d_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C__case_14 x1 x3 x7 cd cs = case x7 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'U'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))))))))))))))) (Curry_Prelude.d_C_show x1 cd cs) cd cs) cd cs
     (Curry_Prelude.C_Just x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_freshVariant x6 cd cs) (d_OP_getTypeVariant_dot_uscore_hash_lambda13_dot_uscore_hash_lambda15 x1)
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_14 x1 x3 l cd cs) (d_C__case_14 x1 x3 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_14 x1 x3 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_14 x1 x3 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_14" [(show x1),(show x3),(show x7)] info)
     _ -> failCons cd (consFail "Inference._case_14" (showCons x7))

nd_C__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C__case_14 x1 x3 x7 s cd cs = case x7 of
     Curry_Prelude.C_Nothing -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'U'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))))))))))))))) (Curry_Prelude.d_C_show x1 cd cs) cd cs) s0 cd cs)))
     (Curry_Prelude.C_Just x6) -> let
          s0 = s
           in (seq s0 (let
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                     in (nd_C_freshVariant x6 s0 cd cs)) (wrapDX (wrapDX id) (d_OP_getTypeVariant_dot_uscore_hash_lambda13_dot_uscore_hash_lambda15 x1))))))
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_14 x1 x3 l s cd cs) (nd_C__case_14 x1 x3 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_14 x1 x3 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_14 x1 x3 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_14" [(show x1),(show x3),(show x7)] info)
     _ -> failCons cd (consFail "Inference._case_14" (showCons x7))

d_C__case_16 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_C__case_16 x1 x3 x4 x6 cd cs = case x6 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'E'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))))))) x3 cd cs)
     (Curry_Prelude.C_Just x5) -> d_C__case_15 x4 x1 x5 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 cd cs) cd cs
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_16 x1 x3 x4 l cd cs) (d_C__case_16 x1 x3 x4 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_16 x1 x3 x4 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_16 x1 x3 x4 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_16" [(show x1),(show x3),(show x4),(show x6)] info)
     _ -> failCons cd (consFail "Inference._case_16" (showCons x6))

d_C__case_15 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_C__case_15 x4 x1 x5 x8 cd cs = case x8 of
     (Curry_Prelude.C_Left x6) -> Curry_Prelude.C_Left x6
     (Curry_Prelude.C_Right x7) -> Curry_Prelude.C_Right (Curry_Prelude.OP_Cons x5 x7)
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (d_C__case_15 x4 x1 x5 l cd cs) (d_C__case_15 x4 x1 x5 r cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> d_C__case_15 x4 x1 x5 z cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((d_C__case_15 x4 x1 x5 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_15" [(show x4),(show x1),(show x5),(show x8)] info)
     _ -> failCons cd (consFail "Inference._case_15" (showCons x8))

d_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_C__case_17 x4 x1 x2 x10 cd cs = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.C_Left x8
     (Curry_Prelude.C_Right x9) -> Curry_Prelude.C_Right (d_C_extractKnownTypes (Curry_Prelude.OP_Cons x2 x9) cd cs)
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (d_C__case_17 x4 x1 x2 l cd cs) (d_C__case_17 x4 x1 x2 r cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> d_C__case_17 x4 x1 x2 z cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((d_C__case_17 x4 x1 x2 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_17" [(show x4),(show x1),(show x2),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_17" (showCons x10))

nd_C__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_C__case_17 x4 x1 x2 x10 s cd cs = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.C_Left x8
     (Curry_Prelude.C_Right x9) -> let
          s0 = s
           in (seq s0 (let
                in (Curry_Prelude.C_Right (let
                     in (nd_C_extractKnownTypes (Curry_Prelude.OP_Cons x2 x9) s0 cd cs)))))
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (nd_C__case_17 x4 x1 x2 l s cd cs) (nd_C__case_17 x4 x1 x2 r s cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> nd_C__case_17 x4 x1 x2 z s cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((nd_C__case_17 x4 x1 x2 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_17" [(show x4),(show x1),(show x2),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_17" (showCons x10))

d_C__case_18 :: Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
d_C__case_18 x7 x2 x1 x10 cd cs = case x10 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) Curry_Prelude.OP_List))))))))))))))))
     (Curry_Prelude.C_Just x9) -> Curry_ErrorState.d_C_evalES (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annFunc x9 cd cs) d_C_inferFunc) (d_C_initTIM x1 cd cs) cd cs
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (d_C__case_18 x7 x2 x1 l cd cs) (d_C__case_18 x7 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> d_C__case_18 x7 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((d_C__case_18 x7 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_18" [(show x7),(show x2),(show x1),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_18" (showCons x10))

nd_C__case_18 :: Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_FuncDecl -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
nd_C__case_18 x7 x2 x1 x10 s cd cs = case x10 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) Curry_Prelude.OP_List))))))))))))))))
     (Curry_Prelude.C_Just x9) -> let
          s3 = s
           in (seq s3 (let
               s2 = leftSupply s3
               s4 = rightSupply s3
               s0 = leftSupply s4
               s1 = rightSupply s4
                in (seq s2 (seq s4 (seq s0 (seq s1 (Curry_ErrorState.nd_C_evalES (let
                     in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let
                          in (nd_C_annFunc x9 s0 cd cs)) (wrapNX id nd_C_inferFunc)))) (let
                     in (nd_C_initTIM x1 s1 cd cs)) s2 cd cs)))))))
     (Curry_Prelude.Choice_C_Maybe d i l r) -> narrow d i (nd_C__case_18 x7 x2 x1 l s cd cs) (nd_C__case_18 x7 x2 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Maybe d i xs) -> narrows cs d i (\z -> nd_C__case_18 x7 x2 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Maybe d c e) -> guardCons d c ((nd_C__case_18 x7 x2 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Maybe d info) -> failCons d (traceFail "Inference._case_18" [(show x7),(show x2),(show x1),(show x10)] info)
     _ -> failCons cd (consFail "Inference._case_18" (showCons x10))

d_C__case_19 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_C__case_19 x2 x1 x5 cd cs = case x5 of
     (Curry_Prelude.C_Left x3) -> Curry_Prelude.C_Left x3
     (Curry_Prelude.C_Right x4) -> d_C_inferProgEnv x4 x2 cd cs
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (d_C__case_19 x2 x1 l cd cs) (d_C__case_19 x2 x1 r cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> d_C__case_19 x2 x1 z cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((d_C__case_19 x2 x1 e cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_19" [(show x2),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_19" (showCons x5))

nd_C__case_19 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
nd_C__case_19 x2 x1 x5 s cd cs = case x5 of
     (Curry_Prelude.C_Left x3) -> Curry_Prelude.C_Left x3
     (Curry_Prelude.C_Right x4) -> let
          s0 = s
           in (seq s0 (let
                in (nd_C_inferProgEnv x4 x2 s0 cd cs)))
     (Curry_Prelude.Choice_C_Either d i l r) -> narrow d i (nd_C__case_19 x2 x1 l s cd cs) (nd_C__case_19 x2 x1 r s cd cs)
     (Curry_Prelude.Choices_C_Either d i xs) -> narrows cs d i (\z -> nd_C__case_19 x2 x1 z s cd cs) xs
     (Curry_Prelude.Guard_C_Either d c e) -> guardCons d c ((nd_C__case_19 x2 x1 e s cd) $! (addCs c cs))
     (Curry_Prelude.Fail_C_Either d info) -> failCons d (traceFail "Inference._case_19" [(show x2),(show x1),(show x5)] info)
     _ -> failCons cd (consFail "Inference._case_19" (showCons x5))